/* NewCardDialog.c generated by valac 0.56.12, the Vala compiler
 * generated from NewCardDialog.vala, do not modify */

/*
* Copyright 2016-2020 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "io.elementary.switchboard.wallet.h"
#include <libsecret/secret.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <granite.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>

enum  {
	WALLET_NEW_CARD_DIALOG_0_PROPERTY,
	WALLET_NEW_CARD_DIALOG_COLLECTION_PROPERTY,
	WALLET_NEW_CARD_DIALOG_NUM_PROPERTIES
};
static GParamSpec* wallet_new_card_dialog_properties[WALLET_NEW_CARD_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _secret_value_unref0(var) ((var == NULL) ? NULL : (var = (secret_value_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _secret_schema_unref0(var) ((var == NULL) ? NULL : (var = (secret_schema_unref (var), NULL)))
typedef struct _WalletNewCardDialogCreateSecretItemData WalletNewCardDialogCreateSecretItemData;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _WalletNewCardDialogPrivate {
	SecretCollection* _collection;
	GtkButton* pay_button;
	GtkEntry* card_expiration_entry;
	GtkEntry* card_cvc_entry;
	WalletCardNumberEntry* card_number_entry;
	gboolean card_valid;
	gboolean expiration_valid;
	gboolean cvc_valid;
};

struct _WalletNewCardDialogCreateSecretItemData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	WalletNewCardDialog* self;
	SecretSchema* schema;
	SecretSchema* _tmp0_;
	gchar* brand;
	WalletCardNumberEntry* _tmp1_;
	WalletCardNumberEntryCardType _tmp2_;
	WalletCardNumberEntryCardType _tmp3_;
	gchar* _tmp4_;
	GHashTable* attributes;
	GHashFunc _tmp5_;
	GEqualFunc _tmp6_;
	GHashTable* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GtkEntry* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* secret;
	WalletCardNumberEntry* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	GtkEntry* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	SecretValue* secret_value;
	SecretValue* _tmp22_;
	gchar* last_four;
	WalletCardNumberEntry* _tmp23_;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
	WalletCardNumberEntry* _tmp26_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	gint _tmp29_;
	gint _tmp30_;
	gchar* _tmp31_;
	gchar* label;
	gchar* _tmp32_;
	SecretCollection* _tmp33_;
	SecretItem* _tmp34_;
	SecretItem* _tmp35_;
	GError* _error_;
	GError* _tmp36_;
	const gchar* _tmp37_;
	GError* _inner_error0_;
};

static gint WalletNewCardDialog_private_offset;
static gpointer wallet_new_card_dialog_parent_class = NULL;

static void wallet_new_card_dialog_create_secret_item_data_free (gpointer _data);
static void wallet_new_card_dialog_create_secret_item (WalletNewCardDialog* self,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
static void wallet_new_card_dialog_create_secret_item_finish (WalletNewCardDialog* self,
                                                       GAsyncResult* _res_);
static gboolean wallet_new_card_dialog_create_secret_item_co (WalletNewCardDialogCreateSecretItemData* _data_);
static void _g_free0_ (gpointer var);
static void wallet_new_card_dialog_create_secret_item_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_);
static void wallet_new_card_dialog_validate_card_number (WalletNewCardDialog* self,
                                                  const gchar* numbers);
static void wallet_new_card_dialog_validate_expiration (WalletNewCardDialog* self,
                                                 const gchar* expiration);
static void wallet_new_card_dialog_validate_cvc (WalletNewCardDialog* self,
                                          const gchar* cvc);
static void wallet_new_card_dialog_validate_form (WalletNewCardDialog* self);
static GObject * wallet_new_card_dialog_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static void _wallet_new_card_dialog___lambda8_ (WalletNewCardDialog* self,
                                         gint response_id);
static void __wallet_new_card_dialog___lambda8__gtk_dialog_response (GtkDialog* _sender,
                                                              gint response_id,
                                                              gpointer self);
static void _wallet_new_card_dialog___lambda9_ (WalletNewCardDialog* self);
static void __wallet_new_card_dialog___lambda9__gtk_editable_changed (GtkEditable* _sender,
                                                               gpointer self);
static void _wallet_new_card_dialog___lambda10_ (WalletNewCardDialog* self);
static void __wallet_new_card_dialog___lambda10__gtk_editable_changed (GtkEditable* _sender,
                                                                gpointer self);
static gboolean _wallet_new_card_dialog___lambda11_ (WalletNewCardDialog* self);
static gboolean __wallet_new_card_dialog___lambda11__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                          GdkEventFocus* event,
                                                                          gpointer self);
static void _wallet_new_card_dialog___lambda12_ (WalletNewCardDialog* self);
static void __wallet_new_card_dialog___lambda12__gtk_editable_changed (GtkEditable* _sender,
                                                                gpointer self);
static void wallet_new_card_dialog_finalize (GObject * obj);
static GType wallet_new_card_dialog_get_type_once (void);
static void _vala_wallet_new_card_dialog_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_wallet_new_card_dialog_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);

static inline gpointer
wallet_new_card_dialog_get_instance_private (WalletNewCardDialog* self)
{
	return G_STRUCT_MEMBER_P (self, WalletNewCardDialog_private_offset);
}

WalletNewCardDialog*
wallet_new_card_dialog_construct (GType object_type,
                                  SecretCollection* collection)
{
	WalletNewCardDialog * self = NULL;
#line 32 "../src/Dialogs/NewCardDialog.vala"
	g_return_val_if_fail (collection != NULL, NULL);
#line 33 "../src/Dialogs/NewCardDialog.vala"
	self = (WalletNewCardDialog*) g_object_new (object_type, "collection", collection, NULL);
#line 32 "../src/Dialogs/NewCardDialog.vala"
	return self;
#line 189 "NewCardDialog.c"
}

WalletNewCardDialog*
wallet_new_card_dialog_new (SecretCollection* collection)
{
#line 32 "../src/Dialogs/NewCardDialog.vala"
	return wallet_new_card_dialog_construct (WALLET_TYPE_NEW_CARD_DIALOG, collection);
#line 197 "NewCardDialog.c"
}

static void
wallet_new_card_dialog_create_secret_item_data_free (gpointer _data)
{
	WalletNewCardDialogCreateSecretItemData* _data_;
	_data_ = _data;
#line 20 "../src/Dialogs/NewCardDialog.vala"
	_g_object_unref0 (_data_->self);
#line 20 "../src/Dialogs/NewCardDialog.vala"
	g_slice_free (WalletNewCardDialogCreateSecretItemData, _data_);
#line 209 "NewCardDialog.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 20 "../src/Dialogs/NewCardDialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 217 "NewCardDialog.c"
}

static void
wallet_new_card_dialog_create_secret_item (WalletNewCardDialog* self,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	WalletNewCardDialogCreateSecretItemData* _data_;
	WalletNewCardDialog* _tmp0_;
#line 20 "../src/Dialogs/NewCardDialog.vala"
	g_return_if_fail (self != NULL);
#line 20 "../src/Dialogs/NewCardDialog.vala"
	_data_ = g_slice_new0 (WalletNewCardDialogCreateSecretItemData);
#line 20 "../src/Dialogs/NewCardDialog.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 20 "../src/Dialogs/NewCardDialog.vala"
	g_task_set_task_data (_data_->_async_result, _data_, wallet_new_card_dialog_create_secret_item_data_free);
#line 20 "../src/Dialogs/NewCardDialog.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 20 "../src/Dialogs/NewCardDialog.vala"
	_data_->self = _tmp0_;
#line 20 "../src/Dialogs/NewCardDialog.vala"
	wallet_new_card_dialog_create_secret_item_co (_data_);
#line 241 "NewCardDialog.c"
}

static void
wallet_new_card_dialog_create_secret_item_finish (WalletNewCardDialog* self,
                                                  GAsyncResult* _res_)
{
	WalletNewCardDialogCreateSecretItemData* _data_;
#line 20 "../src/Dialogs/NewCardDialog.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 251 "NewCardDialog.c"
}

static void
_g_free0_ (gpointer var)
{
#line 152 "../src/Dialogs/NewCardDialog.vala"
	var = (g_free (var), NULL);
#line 259 "NewCardDialog.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1455 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1455 "glib-2.0.vapi"
	end = _tmp0_;
#line 1456 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1456 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1457 "glib-2.0.vapi"
		result = maxlen;
#line 1457 "glib-2.0.vapi"
		return result;
#line 282 "NewCardDialog.c"
	} else {
		gchar* _tmp2_;
#line 1459 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1459 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1459 "glib-2.0.vapi"
		return result;
#line 291 "NewCardDialog.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1466 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1468 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 310 "NewCardDialog.c"
	} else {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 314 "NewCardDialog.c"
	}
#line 1468 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1470 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 320 "NewCardDialog.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1472 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1472 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1472 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 330 "NewCardDialog.c"
	}
#line 1475 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1476 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1477 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 338 "NewCardDialog.c"
	} else {
#line 1479 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 342 "NewCardDialog.c"
	}
#line 1481 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1482 "glib-2.0.vapi"
		len = string_length - offset;
#line 348 "NewCardDialog.c"
	}
#line 1484 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1485 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1485 "glib-2.0.vapi"
	result = _tmp3_;
#line 1485 "glib-2.0.vapi"
	return result;
#line 358 "NewCardDialog.c"
}

static void
wallet_new_card_dialog_create_secret_item_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_)
{
	WalletNewCardDialogCreateSecretItemData* _data_;
#line 178 "../src/Dialogs/NewCardDialog.vala"
	_data_ = _user_data_;
#line 178 "../src/Dialogs/NewCardDialog.vala"
	_data_->_source_object_ = source_object;
#line 178 "../src/Dialogs/NewCardDialog.vala"
	_data_->_res_ = _res_;
#line 178 "../src/Dialogs/NewCardDialog.vala"
	wallet_new_card_dialog_create_secret_item_co (_data_);
#line 375 "NewCardDialog.c"
}

static gboolean
wallet_new_card_dialog_create_secret_item_co (WalletNewCardDialogCreateSecretItemData* _data_)
{
#line 143 "../src/Dialogs/NewCardDialog.vala"
	switch (_data_->_state_) {
#line 143 "../src/Dialogs/NewCardDialog.vala"
		case 0:
#line 385 "NewCardDialog.c"
		goto _state_0;
#line 143 "../src/Dialogs/NewCardDialog.vala"
		case 1:
#line 389 "NewCardDialog.c"
		goto _state_1;
		default:
#line 143 "../src/Dialogs/NewCardDialog.vala"
		g_assert_not_reached ();
#line 394 "NewCardDialog.c"
	}
	_state_0:
#line 144 "../src/Dialogs/NewCardDialog.vala"
	_data_->_tmp0_ = secret_schema_new ("io.elementary.switchboard.wallet", SECRET_SCHEMA_NONE, "brand", SECRET_SCHEMA_ATTRIBUTE_STRING, "exp", SECRET_SCHEMA_ATTRIBUTE_STRING, NULL);
#line 144 "../src/Dialogs/NewCardDialog.vala"
	_data_->schema = _data_->_tmp0_;
#line 150 "../src/Dialogs/NewCardDialog.vala"
	_data_->_tmp1_ = _data_->self->priv->card_number_entry;
#line 150 "../src/Dialogs/NewCardDialog.vala"
	_data_->_tmp2_ = wallet_card_number_entry_get_card_type (_data_->_tmp1_);
#line 150 "../src/Dialogs/NewCardDialog.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 150 "../src/Dialogs/NewCardDialog.vala"
	_data_->_tmp4_ = wallet_card_number_entry_card_type_to_string (_data_->_tmp3_);
#line 150 "../src/Dialogs/NewCardDialog.vala"
	_data_->brand = _data_->_tmp4_;
#line 152 "../src/Dialogs/NewCardDialog.vala"
	_data_->_tmp5_ = g_str_hash;
#line 152 "../src/Dialogs/NewCardDialog.vala"
	_data_->_tmp6_ = g_str_equal;
#line 152 "../src/Dialogs/NewCardDialog.vala"
	_data_->_tmp7_ = g_hash_table_new_full (_data_->_tmp5_, _data_->_tmp6_, _g_free0_, _g_free0_);
#line 152 "../src/Dialogs/NewCardDialog.vala"
	_data_->attributes = _data_->_tmp7_;
#line 153 "../src/Dialogs/NewCardDialog.vala"
	_data_->_tmp8_ = g_strdup ("brand");
#line 153 "../src/Dialogs/NewCardDialog.vala"
	_data_->_tmp9_ = g_strdup (_data_->brand);
#line 153 "../src/Dialogs/NewCardDialog.vala"
	g_hash_table_insert (_data_->attributes, _data_->_tmp8_, _data_->_tmp9_);
#line 154 "../src/Dialogs/NewCardDialog.vala"
	_data_->_tmp10_ = g_strdup ("exp");
#line 154 "../src/Dialogs/NewCardDialog.vala"
	_data_->_tmp11_ = _data_->self->priv->card_expiration_entry;
#line 154 "../src/Dialogs/NewCardDialog.vala"
	_data_->_tmp12_ = gtk_entry_get_text (_data_->_tmp11_);
#line 154 "../src/Dialogs/NewCardDialog.vala"
	_data_->_tmp13_ = _data_->_tmp12_;
#line 154 "../src/Dialogs/NewCardDialog.vala"
	_data_->_tmp14_ = g_strdup (_data_->_tmp13_);
#line 154 "../src/Dialogs/NewCardDialog.vala"
	g_hash_table_insert (_data_->attributes, _data_->_tmp10_, _data_->_tmp14_);
#line 156 "../src/Dialogs/NewCardDialog.vala"
	_data_->_tmp15_ = _data_->self->priv->card_number_entry;
#line 156 "../src/Dialogs/NewCardDialog.vala"
	_data_->_tmp16_ = wallet_card_number_entry_get_card_number (_data_->_tmp15_);
#line 156 "../src/Dialogs/NewCardDialog.vala"
	_data_->_tmp17_ = _data_->_tmp16_;
#line 156 "../src/Dialogs/NewCardDialog.vala"
	_data_->_tmp18_ = _data_->self->priv->card_cvc_entry;
#line 156 "../src/Dialogs/NewCardDialog.vala"
	_data_->_tmp19_ = gtk_entry_get_text (_data_->_tmp18_);
#line 156 "../src/Dialogs/NewCardDialog.vala"
	_data_->_tmp20_ = _data_->_tmp19_;
#line 156 "../src/Dialogs/NewCardDialog.vala"
	_data_->_tmp21_ = g_strdup_printf ("\n" \
"          {\n" \
"            \"card\": {\n" \
"              \"number\": %s,\n" \
"              \"cvc\" %s\n" \
"            }\n" \
"          }\n" \
"        ", _data_->_tmp17_, _data_->_tmp20_);
#line 156 "../src/Dialogs/NewCardDialog.vala"
	_data_->secret = _data_->_tmp21_;
#line 168 "../src/Dialogs/NewCardDialog.vala"
	_data_->_tmp22_ = secret_value_new (_data_->secret, (gssize) -1, "text/json");
#line 168 "../src/Dialogs/NewCardDialog.vala"
	_data_->secret_value = _data_->_tmp22_;
#line 170 "../src/Dialogs/NewCardDialog.vala"
	_data_->_tmp23_ = _data_->self->priv->card_number_entry;
#line 170 "../src/Dialogs/NewCardDialog.vala"
	_data_->_tmp24_ = wallet_card_number_entry_get_card_number (_data_->_tmp23_);
#line 170 "../src/Dialogs/NewCardDialog.vala"
	_data_->_tmp25_ = _data_->_tmp24_;
#line 170 "../src/Dialogs/NewCardDialog.vala"
	_data_->_tmp26_ = _data_->self->priv->card_number_entry;
#line 170 "../src/Dialogs/NewCardDialog.vala"
	_data_->_tmp27_ = wallet_card_number_entry_get_card_number (_data_->_tmp26_);
#line 170 "../src/Dialogs/NewCardDialog.vala"
	_data_->_tmp28_ = _data_->_tmp27_;
#line 170 "../src/Dialogs/NewCardDialog.vala"
	_data_->_tmp29_ = strlen (_data_->_tmp28_);
#line 170 "../src/Dialogs/NewCardDialog.vala"
	_data_->_tmp30_ = _data_->_tmp29_;
#line 170 "../src/Dialogs/NewCardDialog.vala"
	_data_->_tmp31_ = string_substring (_data_->_tmp25_, (glong) (_data_->_tmp30_ - 4), (glong) 4);
#line 170 "../src/Dialogs/NewCardDialog.vala"
	_data_->last_four = _data_->_tmp31_;
#line 175 "../src/Dialogs/NewCardDialog.vala"
	_data_->_tmp32_ = g_strdup_printf (_ ("%s ending in %s"), _data_->brand, _data_->last_four);
#line 175 "../src/Dialogs/NewCardDialog.vala"
	_data_->label = _data_->_tmp32_;
#line 481 "NewCardDialog.c"
	{
#line 178 "../src/Dialogs/NewCardDialog.vala"
		_data_->_tmp33_ = _data_->self->priv->_collection;
#line 178 "../src/Dialogs/NewCardDialog.vala"
		_data_->_state_ = 1;
#line 178 "../src/Dialogs/NewCardDialog.vala"
		secret_item_create (_data_->_tmp33_, _data_->schema, _data_->attributes, _data_->label, _data_->secret_value, SECRET_ITEM_CREATE_NONE, NULL, wallet_new_card_dialog_create_secret_item_ready, _data_);
#line 178 "../src/Dialogs/NewCardDialog.vala"
		return FALSE;
#line 491 "NewCardDialog.c"
		_state_1:
#line 178 "../src/Dialogs/NewCardDialog.vala"
		_data_->_tmp34_ = secret_item_create_finish (_data_->_res_, &_data_->_inner_error0_);
#line 178 "../src/Dialogs/NewCardDialog.vala"
		_data_->_tmp35_ = _data_->_tmp34_;
#line 178 "../src/Dialogs/NewCardDialog.vala"
		_g_object_unref0 (_data_->_tmp35_);
#line 178 "../src/Dialogs/NewCardDialog.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 501 "NewCardDialog.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 177 "../src/Dialogs/NewCardDialog.vala"
		_data_->_error_ = _data_->_inner_error0_;
#line 177 "../src/Dialogs/NewCardDialog.vala"
		_data_->_inner_error0_ = NULL;
#line 188 "../src/Dialogs/NewCardDialog.vala"
		_data_->_tmp36_ = _data_->_error_;
#line 188 "../src/Dialogs/NewCardDialog.vala"
		_data_->_tmp37_ = _data_->_tmp36_->message;
#line 188 "../src/Dialogs/NewCardDialog.vala"
		g_critical ("NewCardDialog.vala:188: %s", _data_->_tmp37_);
#line 177 "../src/Dialogs/NewCardDialog.vala"
		_g_error_free0 (_data_->_error_);
#line 520 "NewCardDialog.c"
	}
	__finally0:
#line 177 "../src/Dialogs/NewCardDialog.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 177 "../src/Dialogs/NewCardDialog.vala"
		_g_free0 (_data_->label);
#line 177 "../src/Dialogs/NewCardDialog.vala"
		_g_free0 (_data_->last_four);
#line 177 "../src/Dialogs/NewCardDialog.vala"
		_secret_value_unref0 (_data_->secret_value);
#line 177 "../src/Dialogs/NewCardDialog.vala"
		_g_free0 (_data_->secret);
#line 177 "../src/Dialogs/NewCardDialog.vala"
		_g_hash_table_unref0 (_data_->attributes);
#line 177 "../src/Dialogs/NewCardDialog.vala"
		_g_free0 (_data_->brand);
#line 177 "../src/Dialogs/NewCardDialog.vala"
		_secret_schema_unref0 (_data_->schema);
#line 177 "../src/Dialogs/NewCardDialog.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 177 "../src/Dialogs/NewCardDialog.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 177 "../src/Dialogs/NewCardDialog.vala"
		g_object_unref (_data_->_async_result);
#line 177 "../src/Dialogs/NewCardDialog.vala"
		return FALSE;
#line 547 "NewCardDialog.c"
	}
#line 143 "../src/Dialogs/NewCardDialog.vala"
	_g_free0 (_data_->label);
#line 143 "../src/Dialogs/NewCardDialog.vala"
	_g_free0 (_data_->last_four);
#line 143 "../src/Dialogs/NewCardDialog.vala"
	_secret_value_unref0 (_data_->secret_value);
#line 143 "../src/Dialogs/NewCardDialog.vala"
	_g_free0 (_data_->secret);
#line 143 "../src/Dialogs/NewCardDialog.vala"
	_g_hash_table_unref0 (_data_->attributes);
#line 143 "../src/Dialogs/NewCardDialog.vala"
	_g_free0 (_data_->brand);
#line 143 "../src/Dialogs/NewCardDialog.vala"
	_secret_schema_unref0 (_data_->schema);
#line 143 "../src/Dialogs/NewCardDialog.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 143 "../src/Dialogs/NewCardDialog.vala"
	if (_data_->_state_ != 0) {
#line 143 "../src/Dialogs/NewCardDialog.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 143 "../src/Dialogs/NewCardDialog.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 571 "NewCardDialog.c"
		}
	}
#line 143 "../src/Dialogs/NewCardDialog.vala"
	g_object_unref (_data_->_async_result);
#line 143 "../src/Dialogs/NewCardDialog.vala"
	return FALSE;
#line 578 "NewCardDialog.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1488 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1489 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1489 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1489 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1490 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1491 "glib-2.0.vapi"
		start = string_length + start;
#line 605 "NewCardDialog.c"
	}
#line 1493 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1494 "glib-2.0.vapi"
		end = string_length + end;
#line 611 "NewCardDialog.c"
	}
#line 1496 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1496 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 617 "NewCardDialog.c"
	} else {
#line 1496 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 621 "NewCardDialog.c"
	}
#line 1496 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1497 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1497 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 629 "NewCardDialog.c"
	} else {
#line 1497 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 633 "NewCardDialog.c"
	}
#line 1497 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1498 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1499 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1499 "glib-2.0.vapi"
	result = _tmp4_;
#line 1499 "glib-2.0.vapi"
	return result;
#line 645 "NewCardDialog.c"
}

static void
wallet_new_card_dialog_validate_card_number (WalletNewCardDialog* self,
                                             const gchar* numbers)
{
	gint char_count = 0;
	gint hash = 0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp2_;
	gint j = 0;
	gint sum = 0;
#line 192 "../src/Dialogs/NewCardDialog.vala"
	g_return_if_fail (self != NULL);
#line 192 "../src/Dialogs/NewCardDialog.vala"
	g_return_if_fail (numbers != NULL);
#line 193 "../src/Dialogs/NewCardDialog.vala"
	char_count = g_utf8_strlen (numbers, (gssize) -1);
#line 195 "../src/Dialogs/NewCardDialog.vala"
	if (char_count < 14) {
#line 196 "../src/Dialogs/NewCardDialog.vala"
		self->priv->card_valid = FALSE;
#line 197 "../src/Dialogs/NewCardDialog.vala"
		return;
#line 671 "NewCardDialog.c"
	}
#line 200 "../src/Dialogs/NewCardDialog.vala"
	_tmp0_ = string_slice (numbers, (glong) (char_count - 1), (glong) char_count);
#line 200 "../src/Dialogs/NewCardDialog.vala"
	_tmp1_ = _tmp0_;
#line 200 "../src/Dialogs/NewCardDialog.vala"
	_tmp2_ = atoi (_tmp1_);
#line 200 "../src/Dialogs/NewCardDialog.vala"
	_g_free0 (_tmp1_);
#line 200 "../src/Dialogs/NewCardDialog.vala"
	hash = _tmp2_;
#line 202 "../src/Dialogs/NewCardDialog.vala"
	j = 1;
#line 203 "../src/Dialogs/NewCardDialog.vala"
	sum = 0;
#line 687 "NewCardDialog.c"
	{
		gint i = 0;
#line 204 "../src/Dialogs/NewCardDialog.vala"
		i = char_count - 1;
#line 692 "NewCardDialog.c"
		{
			gboolean _tmp3_ = FALSE;
#line 204 "../src/Dialogs/NewCardDialog.vala"
			_tmp3_ = TRUE;
#line 204 "../src/Dialogs/NewCardDialog.vala"
			while (TRUE) {
#line 699 "NewCardDialog.c"
				gint number = 0;
				gchar* _tmp5_;
				gchar* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
#line 204 "../src/Dialogs/NewCardDialog.vala"
				if (!_tmp3_) {
#line 707 "NewCardDialog.c"
					gint _tmp4_;
#line 204 "../src/Dialogs/NewCardDialog.vala"
					_tmp4_ = i;
#line 204 "../src/Dialogs/NewCardDialog.vala"
					i = _tmp4_ - 1;
#line 713 "NewCardDialog.c"
				}
#line 204 "../src/Dialogs/NewCardDialog.vala"
				_tmp3_ = FALSE;
#line 204 "../src/Dialogs/NewCardDialog.vala"
				if (!(i > 0)) {
#line 204 "../src/Dialogs/NewCardDialog.vala"
					break;
#line 721 "NewCardDialog.c"
				}
#line 205 "../src/Dialogs/NewCardDialog.vala"
				_tmp5_ = string_slice (numbers, (glong) (i - 1), (glong) i);
#line 205 "../src/Dialogs/NewCardDialog.vala"
				_tmp6_ = _tmp5_;
#line 205 "../src/Dialogs/NewCardDialog.vala"
				_tmp7_ = atoi (_tmp6_);
#line 205 "../src/Dialogs/NewCardDialog.vala"
				_g_free0 (_tmp6_);
#line 205 "../src/Dialogs/NewCardDialog.vala"
				number = _tmp7_;
#line 206 "../src/Dialogs/NewCardDialog.vala"
				_tmp8_ = j;
#line 206 "../src/Dialogs/NewCardDialog.vala"
				j = _tmp8_ + 1;
#line 206 "../src/Dialogs/NewCardDialog.vala"
				if ((_tmp8_ % 2) == 1) {
#line 207 "../src/Dialogs/NewCardDialog.vala"
					number = number * 2;
#line 208 "../src/Dialogs/NewCardDialog.vala"
					if (number > 9) {
#line 209 "../src/Dialogs/NewCardDialog.vala"
						number = number - 9;
#line 745 "NewCardDialog.c"
					}
				}
#line 213 "../src/Dialogs/NewCardDialog.vala"
				sum += number;
#line 750 "NewCardDialog.c"
			}
		}
	}
#line 216 "../src/Dialogs/NewCardDialog.vala"
	self->priv->card_valid = ((10 - (sum % 10)) % 10) == hash;
#line 756 "NewCardDialog.c"
}

static void
wallet_new_card_dialog_validate_expiration (WalletNewCardDialog* self,
                                            const gchar* expiration)
{
	gint _tmp0_;
	gint _tmp1_;
	GError* _inner_error0_ = NULL;
#line 219 "../src/Dialogs/NewCardDialog.vala"
	g_return_if_fail (self != NULL);
#line 219 "../src/Dialogs/NewCardDialog.vala"
	g_return_if_fail (expiration != NULL);
#line 220 "../src/Dialogs/NewCardDialog.vala"
	_tmp0_ = strlen (expiration);
#line 220 "../src/Dialogs/NewCardDialog.vala"
	_tmp1_ = _tmp0_;
#line 220 "../src/Dialogs/NewCardDialog.vala"
	if (_tmp1_ < 4) {
#line 221 "../src/Dialogs/NewCardDialog.vala"
		self->priv->expiration_valid = FALSE;
#line 778 "NewCardDialog.c"
	} else {
		{
			GRegex* regex = NULL;
			GRegex* _tmp2_;
			GRegex* _tmp3_;
#line 224 "../src/Dialogs/NewCardDialog.vala"
			_tmp2_ = g_regex_new ("^[0-9]{2}\\/?[0-9]{2}$", 0, 0, &_inner_error0_);
#line 224 "../src/Dialogs/NewCardDialog.vala"
			regex = _tmp2_;
#line 224 "../src/Dialogs/NewCardDialog.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 790 "NewCardDialog.c"
				goto __catch0_g_error;
			}
#line 225 "../src/Dialogs/NewCardDialog.vala"
			_tmp3_ = regex;
#line 225 "../src/Dialogs/NewCardDialog.vala"
			self->priv->expiration_valid = g_regex_match (_tmp3_, expiration, 0, NULL);
#line 223 "../src/Dialogs/NewCardDialog.vala"
			_g_regex_unref0 (regex);
#line 799 "NewCardDialog.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp4_;
			const gchar* _tmp5_;
#line 223 "../src/Dialogs/NewCardDialog.vala"
			e = _inner_error0_;
#line 223 "../src/Dialogs/NewCardDialog.vala"
			_inner_error0_ = NULL;
#line 227 "../src/Dialogs/NewCardDialog.vala"
			_tmp4_ = e;
#line 227 "../src/Dialogs/NewCardDialog.vala"
			_tmp5_ = _tmp4_->message;
#line 227 "../src/Dialogs/NewCardDialog.vala"
			g_critical ("NewCardDialog.vala:227: %s", _tmp5_);
#line 228 "../src/Dialogs/NewCardDialog.vala"
			self->priv->expiration_valid = FALSE;
#line 223 "../src/Dialogs/NewCardDialog.vala"
			_g_error_free0 (e);
#line 821 "NewCardDialog.c"
		}
		__finally0:
#line 223 "../src/Dialogs/NewCardDialog.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 223 "../src/Dialogs/NewCardDialog.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 223 "../src/Dialogs/NewCardDialog.vala"
			g_clear_error (&_inner_error0_);
#line 223 "../src/Dialogs/NewCardDialog.vala"
			return;
#line 832 "NewCardDialog.c"
		}
	}
}

static void
wallet_new_card_dialog_validate_cvc (WalletNewCardDialog* self,
                                     const gchar* cvc)
{
	GError* _inner_error0_ = NULL;
#line 233 "../src/Dialogs/NewCardDialog.vala"
	g_return_if_fail (self != NULL);
#line 233 "../src/Dialogs/NewCardDialog.vala"
	g_return_if_fail (cvc != NULL);
#line 846 "NewCardDialog.c"
	{
		GRegex* regex = NULL;
		GRegex* _tmp0_;
#line 235 "../src/Dialogs/NewCardDialog.vala"
		_tmp0_ = g_regex_new ("[0-9]{3,4}", 0, 0, &_inner_error0_);
#line 235 "../src/Dialogs/NewCardDialog.vala"
		regex = _tmp0_;
#line 235 "../src/Dialogs/NewCardDialog.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 856 "NewCardDialog.c"
			goto __catch0_g_error;
		}
#line 236 "../src/Dialogs/NewCardDialog.vala"
		self->priv->cvc_valid = g_regex_match (regex, cvc, 0, NULL);
#line 234 "../src/Dialogs/NewCardDialog.vala"
		_g_regex_unref0 (regex);
#line 863 "NewCardDialog.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 234 "../src/Dialogs/NewCardDialog.vala"
		e = _inner_error0_;
#line 234 "../src/Dialogs/NewCardDialog.vala"
		_inner_error0_ = NULL;
#line 238 "../src/Dialogs/NewCardDialog.vala"
		_tmp1_ = e;
#line 238 "../src/Dialogs/NewCardDialog.vala"
		_tmp2_ = _tmp1_->message;
#line 238 "../src/Dialogs/NewCardDialog.vala"
		g_critical ("NewCardDialog.vala:238: %s", _tmp2_);
#line 239 "../src/Dialogs/NewCardDialog.vala"
		self->priv->cvc_valid = FALSE;
#line 234 "../src/Dialogs/NewCardDialog.vala"
		_g_error_free0 (e);
#line 885 "NewCardDialog.c"
	}
	__finally0:
#line 234 "../src/Dialogs/NewCardDialog.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 234 "../src/Dialogs/NewCardDialog.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 234 "../src/Dialogs/NewCardDialog.vala"
		g_clear_error (&_inner_error0_);
#line 234 "../src/Dialogs/NewCardDialog.vala"
		return;
#line 896 "NewCardDialog.c"
	}
}

static void
wallet_new_card_dialog_validate_form (WalletNewCardDialog* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GtkButton* _tmp2_;
#line 243 "../src/Dialogs/NewCardDialog.vala"
	g_return_if_fail (self != NULL);
#line 244 "../src/Dialogs/NewCardDialog.vala"
	if (self->priv->card_valid) {
#line 244 "../src/Dialogs/NewCardDialog.vala"
		_tmp1_ = self->priv->expiration_valid;
#line 912 "NewCardDialog.c"
	} else {
#line 244 "../src/Dialogs/NewCardDialog.vala"
		_tmp1_ = FALSE;
#line 916 "NewCardDialog.c"
	}
#line 244 "../src/Dialogs/NewCardDialog.vala"
	if (_tmp1_) {
#line 244 "../src/Dialogs/NewCardDialog.vala"
		_tmp0_ = self->priv->cvc_valid;
#line 922 "NewCardDialog.c"
	} else {
#line 244 "../src/Dialogs/NewCardDialog.vala"
		_tmp0_ = FALSE;
#line 926 "NewCardDialog.c"
	}
#line 244 "../src/Dialogs/NewCardDialog.vala"
	_tmp2_ = self->priv->pay_button;
#line 244 "../src/Dialogs/NewCardDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp2_, _tmp0_);
#line 932 "NewCardDialog.c"
}

SecretCollection*
wallet_new_card_dialog_get_collection (WalletNewCardDialog* self)
{
	SecretCollection* result;
	SecretCollection* _tmp0_;
#line 21 "../src/Dialogs/NewCardDialog.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 21 "../src/Dialogs/NewCardDialog.vala"
	_tmp0_ = self->priv->_collection;
#line 21 "../src/Dialogs/NewCardDialog.vala"
	result = _tmp0_;
#line 21 "../src/Dialogs/NewCardDialog.vala"
	return result;
#line 948 "NewCardDialog.c"
}

static void
wallet_new_card_dialog_set_collection (WalletNewCardDialog* self,
                                       SecretCollection* value)
{
	SecretCollection* old_value;
#line 21 "../src/Dialogs/NewCardDialog.vala"
	g_return_if_fail (self != NULL);
#line 21 "../src/Dialogs/NewCardDialog.vala"
	old_value = wallet_new_card_dialog_get_collection (self);
#line 21 "../src/Dialogs/NewCardDialog.vala"
	if (old_value != value) {
#line 962 "NewCardDialog.c"
		SecretCollection* _tmp0_;
#line 21 "../src/Dialogs/NewCardDialog.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 21 "../src/Dialogs/NewCardDialog.vala"
		_g_object_unref0 (self->priv->_collection);
#line 21 "../src/Dialogs/NewCardDialog.vala"
		self->priv->_collection = _tmp0_;
#line 21 "../src/Dialogs/NewCardDialog.vala"
		g_object_notify_by_pspec ((GObject *) self, wallet_new_card_dialog_properties[WALLET_NEW_CARD_DIALOG_COLLECTION_PROPERTY]);
#line 972 "NewCardDialog.c"
	}
}

static void
_wallet_new_card_dialog___lambda8_ (WalletNewCardDialog* self,
                                    gint response_id)
{
#line 110 "../src/Dialogs/NewCardDialog.vala"
	if (response_id == ((gint) GTK_RESPONSE_APPLY)) {
#line 111 "../src/Dialogs/NewCardDialog.vala"
		wallet_new_card_dialog_create_secret_item (self, NULL, NULL);
#line 984 "NewCardDialog.c"
	}
#line 114 "../src/Dialogs/NewCardDialog.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 988 "NewCardDialog.c"
}

static void
__wallet_new_card_dialog___lambda8__gtk_dialog_response (GtkDialog* _sender,
                                                         gint response_id,
                                                         gpointer self)
{
#line 109 "../src/Dialogs/NewCardDialog.vala"
	_wallet_new_card_dialog___lambda8_ ((WalletNewCardDialog*) self, response_id);
#line 998 "NewCardDialog.c"
}

static void
_wallet_new_card_dialog___lambda9_ (WalletNewCardDialog* self)
{
	WalletCardNumberEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 118 "../src/Dialogs/NewCardDialog.vala"
	_tmp0_ = self->priv->card_number_entry;
#line 118 "../src/Dialogs/NewCardDialog.vala"
	_tmp1_ = wallet_card_number_entry_get_card_number (_tmp0_);
#line 118 "../src/Dialogs/NewCardDialog.vala"
	_tmp2_ = _tmp1_;
#line 118 "../src/Dialogs/NewCardDialog.vala"
	wallet_new_card_dialog_validate_card_number (self, _tmp2_);
#line 119 "../src/Dialogs/NewCardDialog.vala"
	wallet_new_card_dialog_validate_form (self);
#line 1017 "NewCardDialog.c"
}

static void
__wallet_new_card_dialog___lambda9__gtk_editable_changed (GtkEditable* _sender,
                                                          gpointer self)
{
#line 117 "../src/Dialogs/NewCardDialog.vala"
	_wallet_new_card_dialog___lambda9_ ((WalletNewCardDialog*) self);
#line 1026 "NewCardDialog.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1543 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1048 "NewCardDialog.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1052 "NewCardDialog.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1058 "NewCardDialog.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1062 "NewCardDialog.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1066 "NewCardDialog.c"
		gchar* _tmp2_;
#line 1544 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1544 "glib-2.0.vapi"
		result = _tmp2_;
#line 1544 "glib-2.0.vapi"
		return result;
#line 1074 "NewCardDialog.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1547 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1547 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1547 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1547 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1547 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1547 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1547 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1547 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1102 "NewCardDialog.c"
				goto __catch0_g_regex_error;
			}
#line 1547 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1547 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1547 "glib-2.0.vapi"
			return NULL;
#line 1111 "NewCardDialog.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1548 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1548 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1548 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1548 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1125 "NewCardDialog.c"
				goto __catch0_g_regex_error;
			}
#line 1548 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1548 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1548 "glib-2.0.vapi"
			return NULL;
#line 1134 "NewCardDialog.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1548 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1548 "glib-2.0.vapi"
		result = _tmp10_;
#line 1548 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1548 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
		return result;
#line 1148 "NewCardDialog.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1546 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1157 "NewCardDialog.c"
	}
	__finally0:
#line 1546 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1546 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1546 "glib-2.0.vapi"
	return NULL;
#line 1166 "NewCardDialog.c"
}

static void
_wallet_new_card_dialog___lambda10_ (WalletNewCardDialog* self)
{
	GtkEntry* _tmp0_;
	GtkEntry* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GtkEntry* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
#line 123 "../src/Dialogs/NewCardDialog.vala"
	_tmp0_ = self->priv->card_expiration_entry;
#line 123 "../src/Dialogs/NewCardDialog.vala"
	_tmp1_ = self->priv->card_expiration_entry;
#line 123 "../src/Dialogs/NewCardDialog.vala"
	_tmp2_ = gtk_entry_get_text (_tmp1_);
#line 123 "../src/Dialogs/NewCardDialog.vala"
	_tmp3_ = _tmp2_;
#line 123 "../src/Dialogs/NewCardDialog.vala"
	_tmp4_ = string_replace (_tmp3_, " ", "");
#line 123 "../src/Dialogs/NewCardDialog.vala"
	_tmp5_ = _tmp4_;
#line 123 "../src/Dialogs/NewCardDialog.vala"
	gtk_entry_set_text (_tmp0_, _tmp5_);
#line 123 "../src/Dialogs/NewCardDialog.vala"
	_g_free0 (_tmp5_);
#line 124 "../src/Dialogs/NewCardDialog.vala"
	_tmp6_ = self->priv->card_expiration_entry;
#line 124 "../src/Dialogs/NewCardDialog.vala"
	_tmp7_ = gtk_entry_get_text (_tmp6_);
#line 124 "../src/Dialogs/NewCardDialog.vala"
	_tmp8_ = _tmp7_;
#line 124 "../src/Dialogs/NewCardDialog.vala"
	wallet_new_card_dialog_validate_expiration (self, _tmp8_);
#line 125 "../src/Dialogs/NewCardDialog.vala"
	wallet_new_card_dialog_validate_form (self);
#line 1207 "NewCardDialog.c"
}

static void
__wallet_new_card_dialog___lambda10__gtk_editable_changed (GtkEditable* _sender,
                                                           gpointer self)
{
#line 122 "../src/Dialogs/NewCardDialog.vala"
	_wallet_new_card_dialog___lambda10_ ((WalletNewCardDialog*) self);
#line 1216 "NewCardDialog.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1539 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1539 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1539 "glib-2.0.vapi"
	return result;
#line 1235 "NewCardDialog.c"
}

static gboolean
_wallet_new_card_dialog___lambda11_ (WalletNewCardDialog* self)
{
	gchar* expiration_text = NULL;
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
#line 129 "../src/Dialogs/NewCardDialog.vala"
	_tmp0_ = self->priv->card_expiration_entry;
#line 129 "../src/Dialogs/NewCardDialog.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 129 "../src/Dialogs/NewCardDialog.vala"
	_tmp2_ = _tmp1_;
#line 129 "../src/Dialogs/NewCardDialog.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 129 "../src/Dialogs/NewCardDialog.vala"
	expiration_text = _tmp3_;
#line 130 "../src/Dialogs/NewCardDialog.vala"
	_tmp5_ = expiration_text;
#line 130 "../src/Dialogs/NewCardDialog.vala"
	if (!string_contains (_tmp5_, "/")) {
#line 1262 "NewCardDialog.c"
		const gchar* _tmp6_;
#line 130 "../src/Dialogs/NewCardDialog.vala"
		_tmp6_ = expiration_text;
#line 130 "../src/Dialogs/NewCardDialog.vala"
		_tmp4_ = g_utf8_strlen (_tmp6_, (gssize) -1) > 2;
#line 1268 "NewCardDialog.c"
	} else {
#line 130 "../src/Dialogs/NewCardDialog.vala"
		_tmp4_ = FALSE;
#line 1272 "NewCardDialog.c"
	}
#line 130 "../src/Dialogs/NewCardDialog.vala"
	if (_tmp4_) {
#line 1276 "NewCardDialog.c"
		gint position = 0;
		GtkEntry* _tmp7_;
#line 131 "../src/Dialogs/NewCardDialog.vala"
		position = 2;
#line 132 "../src/Dialogs/NewCardDialog.vala"
		_tmp7_ = self->priv->card_expiration_entry;
#line 132 "../src/Dialogs/NewCardDialog.vala"
		g_signal_emit_by_name ((GtkEditable*) _tmp7_, "insert-text", "/", 1, &position);
#line 1285 "NewCardDialog.c"
	}
#line 128 "../src/Dialogs/NewCardDialog.vala"
	_g_free0 (expiration_text);
#line 1289 "NewCardDialog.c"
}

static gboolean
__wallet_new_card_dialog___lambda11__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                 GdkEventFocus* event,
                                                                 gpointer self)
{
	gboolean result;
	result = _wallet_new_card_dialog___lambda11_ ((WalletNewCardDialog*) self);
#line 128 "../src/Dialogs/NewCardDialog.vala"
	return result;
#line 1301 "NewCardDialog.c"
}

static void
_wallet_new_card_dialog___lambda12_ (WalletNewCardDialog* self)
{
	GtkEntry* _tmp0_;
	GtkEntry* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GtkEntry* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
#line 137 "../src/Dialogs/NewCardDialog.vala"
	_tmp0_ = self->priv->card_cvc_entry;
#line 137 "../src/Dialogs/NewCardDialog.vala"
	_tmp1_ = self->priv->card_cvc_entry;
#line 137 "../src/Dialogs/NewCardDialog.vala"
	_tmp2_ = gtk_entry_get_text (_tmp1_);
#line 137 "../src/Dialogs/NewCardDialog.vala"
	_tmp3_ = _tmp2_;
#line 137 "../src/Dialogs/NewCardDialog.vala"
	_tmp4_ = string_replace (_tmp3_, " ", "");
#line 137 "../src/Dialogs/NewCardDialog.vala"
	_tmp5_ = _tmp4_;
#line 137 "../src/Dialogs/NewCardDialog.vala"
	gtk_entry_set_text (_tmp0_, _tmp5_);
#line 137 "../src/Dialogs/NewCardDialog.vala"
	_g_free0 (_tmp5_);
#line 138 "../src/Dialogs/NewCardDialog.vala"
	_tmp6_ = self->priv->card_cvc_entry;
#line 138 "../src/Dialogs/NewCardDialog.vala"
	_tmp7_ = gtk_entry_get_text (_tmp6_);
#line 138 "../src/Dialogs/NewCardDialog.vala"
	_tmp8_ = _tmp7_;
#line 138 "../src/Dialogs/NewCardDialog.vala"
	wallet_new_card_dialog_validate_cvc (self, _tmp8_);
#line 139 "../src/Dialogs/NewCardDialog.vala"
	wallet_new_card_dialog_validate_form (self);
#line 1342 "NewCardDialog.c"
}

static void
__wallet_new_card_dialog___lambda12__gtk_editable_changed (GtkEditable* _sender,
                                                           gpointer self)
{
#line 136 "../src/Dialogs/NewCardDialog.vala"
	_wallet_new_card_dialog___lambda12_ ((WalletNewCardDialog*) self);
#line 1351 "NewCardDialog.c"
}

static GObject *
wallet_new_card_dialog_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WalletNewCardDialog * self;
	GtkImage* image = NULL;
	GtkImage* _tmp0_;
	GtkImage* _tmp1_;
	GtkLabel* primary_label = NULL;
	GtkLabel* _tmp2_;
	GtkLabel* _tmp3_;
	GtkStyleContext* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* secondary_label = NULL;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	WalletCardNumberEntry* _tmp11_;
	WalletCardNumberEntry* _tmp12_;
	WalletCardNumberEntry* _tmp13_;
	WalletCardNumberEntry* _tmp14_;
	WalletCardNumberEntry* _tmp15_;
	GtkEntry* _tmp16_;
	GtkEntry* _tmp17_;
	GtkEntry* _tmp18_;
	GtkEntry* _tmp19_;
	GtkEntry* _tmp20_;
	GtkEntry* _tmp21_;
	GtkEntry* _tmp22_;
	GtkEntry* _tmp23_;
	GtkEntry* _tmp24_;
	GtkEntry* _tmp25_;
	GtkEntry* _tmp26_;
	GtkEntry* _tmp27_;
	GtkEntry* _tmp28_;
	GtkEntry* _tmp29_;
	GtkEntry* _tmp30_;
	GtkGrid* card_grid_bottom = NULL;
	GtkGrid* _tmp31_;
	GtkGrid* _tmp32_;
	GtkStyleContext* _tmp33_;
	GtkGrid* _tmp34_;
	GtkEntry* _tmp35_;
	GtkGrid* _tmp36_;
	GtkEntry* _tmp37_;
	GtkGrid* card_grid = NULL;
	GtkGrid* _tmp38_;
	GtkGrid* _tmp39_;
	GtkStyleContext* _tmp40_;
	GtkGrid* _tmp41_;
	GtkGrid* _tmp42_;
	WalletCardNumberEntry* _tmp43_;
	GtkGrid* _tmp44_;
	GtkGrid* _tmp45_;
	GtkGrid* card_layout = NULL;
	GtkGrid* _tmp46_;
	GtkGrid* _tmp47_;
	GtkStyleContext* _tmp48_;
	GtkGrid* _tmp49_;
	GtkGrid* _tmp50_;
	GtkGrid* _tmp51_;
	GtkGrid* _tmp52_;
	GtkGrid* _tmp53_;
	GtkImage* _tmp54_;
	GtkGrid* _tmp55_;
	GtkLabel* _tmp56_;
	GtkGrid* _tmp57_;
	GtkLabel* _tmp58_;
	GtkGrid* _tmp59_;
	GtkGrid* _tmp60_;
	GtkGrid* _tmp61_;
	GtkBox* _tmp62_;
	GtkGrid* _tmp63_;
	GtkBox* _tmp64_;
	GtkWidget* _tmp65_;
	GtkButton* _tmp66_;
	GtkButton* _tmp67_;
	GtkStyleContext* _tmp68_;
	GtkButton* _tmp69_;
	GtkButton* _tmp70_;
	WalletCardNumberEntry* _tmp71_;
	GtkEntry* _tmp72_;
	GtkEntry* _tmp73_;
	GtkEntry* _tmp74_;
#line 36 "../src/Dialogs/NewCardDialog.vala"
	parent_class = G_OBJECT_CLASS (wallet_new_card_dialog_parent_class);
#line 36 "../src/Dialogs/NewCardDialog.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 36 "../src/Dialogs/NewCardDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WALLET_TYPE_NEW_CARD_DIALOG, WalletNewCardDialog);
#line 37 "../src/Dialogs/NewCardDialog.vala"
	_tmp0_ = (GtkImage*) gtk_image_new_from_icon_name ("payment-card", (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 37 "../src/Dialogs/NewCardDialog.vala"
	g_object_ref_sink (_tmp0_);
#line 37 "../src/Dialogs/NewCardDialog.vala"
	image = _tmp0_;
#line 38 "../src/Dialogs/NewCardDialog.vala"
	_tmp1_ = image;
#line 38 "../src/Dialogs/NewCardDialog.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp1_, GTK_ALIGN_START);
#line 40 "../src/Dialogs/NewCardDialog.vala"
	_tmp2_ = (GtkLabel*) gtk_label_new (_ ("Add a new card"));
#line 40 "../src/Dialogs/NewCardDialog.vala"
	g_object_ref_sink (_tmp2_);
#line 40 "../src/Dialogs/NewCardDialog.vala"
	primary_label = _tmp2_;
#line 41 "../src/Dialogs/NewCardDialog.vala"
	_tmp3_ = primary_label;
#line 41 "../src/Dialogs/NewCardDialog.vala"
	_tmp4_ = gtk_widget_get_style_context ((GtkWidget*) _tmp3_);
#line 41 "../src/Dialogs/NewCardDialog.vala"
	gtk_style_context_add_class (_tmp4_, GRANITE_STYLE_CLASS_PRIMARY_LABEL);
#line 42 "../src/Dialogs/NewCardDialog.vala"
	_tmp5_ = primary_label;
#line 42 "../src/Dialogs/NewCardDialog.vala"
	gtk_label_set_xalign (_tmp5_, (gfloat) 0);
#line 44 "../src/Dialogs/NewCardDialog.vala"
	_tmp6_ = (GtkLabel*) gtk_label_new (_ ("Card information is stored encrypted, on your device."));
#line 44 "../src/Dialogs/NewCardDialog.vala"
	g_object_ref_sink (_tmp6_);
#line 44 "../src/Dialogs/NewCardDialog.vala"
	secondary_label = _tmp6_;
#line 45 "../src/Dialogs/NewCardDialog.vala"
	_tmp7_ = secondary_label;
#line 45 "../src/Dialogs/NewCardDialog.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp7_, 18);
#line 46 "../src/Dialogs/NewCardDialog.vala"
	_tmp8_ = secondary_label;
#line 46 "../src/Dialogs/NewCardDialog.vala"
	gtk_label_set_max_width_chars (_tmp8_, 50);
#line 47 "../src/Dialogs/NewCardDialog.vala"
	_tmp9_ = secondary_label;
#line 47 "../src/Dialogs/NewCardDialog.vala"
	g_object_set (_tmp9_, "wrap", TRUE, NULL);
#line 48 "../src/Dialogs/NewCardDialog.vala"
	_tmp10_ = secondary_label;
#line 48 "../src/Dialogs/NewCardDialog.vala"
	gtk_label_set_xalign (_tmp10_, (gfloat) 0);
#line 50 "../src/Dialogs/NewCardDialog.vala"
	_tmp11_ = wallet_card_number_entry_new ();
#line 50 "../src/Dialogs/NewCardDialog.vala"
	g_object_ref_sink (_tmp11_);
#line 50 "../src/Dialogs/NewCardDialog.vala"
	_g_object_unref0 (self->priv->card_number_entry);
#line 50 "../src/Dialogs/NewCardDialog.vala"
	self->priv->card_number_entry = _tmp11_;
#line 51 "../src/Dialogs/NewCardDialog.vala"
	_tmp12_ = self->priv->card_number_entry;
#line 51 "../src/Dialogs/NewCardDialog.vala"
	gtk_entry_set_activates_default ((GtkEntry*) _tmp12_, TRUE);
#line 52 "../src/Dialogs/NewCardDialog.vala"
	_tmp13_ = self->priv->card_number_entry;
#line 52 "../src/Dialogs/NewCardDialog.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp13_, TRUE);
#line 53 "../src/Dialogs/NewCardDialog.vala"
	_tmp14_ = self->priv->card_number_entry;
#line 53 "../src/Dialogs/NewCardDialog.vala"
	_tmp15_ = self->priv->card_number_entry;
#line 53 "../src/Dialogs/NewCardDialog.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp14_, "has-focus", (GObject*) _tmp15_, "visibility", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 55 "../src/Dialogs/NewCardDialog.vala"
	_tmp16_ = (GtkEntry*) gtk_entry_new ();
#line 55 "../src/Dialogs/NewCardDialog.vala"
	g_object_ref_sink (_tmp16_);
#line 55 "../src/Dialogs/NewCardDialog.vala"
	_g_object_unref0 (self->priv->card_expiration_entry);
#line 55 "../src/Dialogs/NewCardDialog.vala"
	self->priv->card_expiration_entry = _tmp16_;
#line 56 "../src/Dialogs/NewCardDialog.vala"
	_tmp17_ = self->priv->card_expiration_entry;
#line 56 "../src/Dialogs/NewCardDialog.vala"
	gtk_entry_set_activates_default (_tmp17_, TRUE);
#line 57 "../src/Dialogs/NewCardDialog.vala"
	_tmp18_ = self->priv->card_expiration_entry;
#line 57 "../src/Dialogs/NewCardDialog.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp18_, TRUE);
#line 58 "../src/Dialogs/NewCardDialog.vala"
	_tmp19_ = self->priv->card_expiration_entry;
#line 58 "../src/Dialogs/NewCardDialog.vala"
	gtk_entry_set_max_length (_tmp19_, 5);
#line 60 "../src/Dialogs/NewCardDialog.vala"
	_tmp20_ = self->priv->card_expiration_entry;
#line 60 "../src/Dialogs/NewCardDialog.vala"
	gtk_entry_set_placeholder_text (_tmp20_, _ ("MM / YY"));
#line 61 "../src/Dialogs/NewCardDialog.vala"
	_tmp21_ = self->priv->card_expiration_entry;
#line 61 "../src/Dialogs/NewCardDialog.vala"
	g_object_set (_tmp21_, "primary-icon-name", "office-calendar-symbolic", NULL);
#line 63 "../src/Dialogs/NewCardDialog.vala"
	_tmp22_ = (GtkEntry*) gtk_entry_new ();
#line 63 "../src/Dialogs/NewCardDialog.vala"
	g_object_ref_sink (_tmp22_);
#line 63 "../src/Dialogs/NewCardDialog.vala"
	_g_object_unref0 (self->priv->card_cvc_entry);
#line 63 "../src/Dialogs/NewCardDialog.vala"
	self->priv->card_cvc_entry = _tmp22_;
#line 64 "../src/Dialogs/NewCardDialog.vala"
	_tmp23_ = self->priv->card_cvc_entry;
#line 64 "../src/Dialogs/NewCardDialog.vala"
	gtk_entry_set_activates_default (_tmp23_, TRUE);
#line 65 "../src/Dialogs/NewCardDialog.vala"
	_tmp24_ = self->priv->card_cvc_entry;
#line 65 "../src/Dialogs/NewCardDialog.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp24_, TRUE);
#line 66 "../src/Dialogs/NewCardDialog.vala"
	_tmp25_ = self->priv->card_cvc_entry;
#line 66 "../src/Dialogs/NewCardDialog.vala"
	gtk_entry_set_input_purpose (_tmp25_, GTK_INPUT_PURPOSE_DIGITS);
#line 67 "../src/Dialogs/NewCardDialog.vala"
	_tmp26_ = self->priv->card_cvc_entry;
#line 67 "../src/Dialogs/NewCardDialog.vala"
	gtk_entry_set_max_length (_tmp26_, 4);
#line 68 "../src/Dialogs/NewCardDialog.vala"
	_tmp27_ = self->priv->card_cvc_entry;
#line 68 "../src/Dialogs/NewCardDialog.vala"
	gtk_entry_set_placeholder_text (_tmp27_, _ ("CVC"));
#line 69 "../src/Dialogs/NewCardDialog.vala"
	_tmp28_ = self->priv->card_cvc_entry;
#line 69 "../src/Dialogs/NewCardDialog.vala"
	g_object_set (_tmp28_, "primary-icon-name", "channel-secure-symbolic", NULL);
#line 70 "../src/Dialogs/NewCardDialog.vala"
	_tmp29_ = self->priv->card_cvc_entry;
#line 70 "../src/Dialogs/NewCardDialog.vala"
	_tmp30_ = self->priv->card_cvc_entry;
#line 70 "../src/Dialogs/NewCardDialog.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp29_, "has-focus", (GObject*) _tmp30_, "visibility", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 72 "../src/Dialogs/NewCardDialog.vala"
	_tmp31_ = (GtkGrid*) gtk_grid_new ();
#line 72 "../src/Dialogs/NewCardDialog.vala"
	g_object_ref_sink (_tmp31_);
#line 72 "../src/Dialogs/NewCardDialog.vala"
	card_grid_bottom = _tmp31_;
#line 73 "../src/Dialogs/NewCardDialog.vala"
	_tmp32_ = card_grid_bottom;
#line 73 "../src/Dialogs/NewCardDialog.vala"
	_tmp33_ = gtk_widget_get_style_context ((GtkWidget*) _tmp32_);
#line 73 "../src/Dialogs/NewCardDialog.vala"
	gtk_style_context_add_class (_tmp33_, GTK_STYLE_CLASS_LINKED);
#line 74 "../src/Dialogs/NewCardDialog.vala"
	_tmp34_ = card_grid_bottom;
#line 74 "../src/Dialogs/NewCardDialog.vala"
	_tmp35_ = self->priv->card_expiration_entry;
#line 74 "../src/Dialogs/NewCardDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp34_, (GtkWidget*) _tmp35_);
#line 75 "../src/Dialogs/NewCardDialog.vala"
	_tmp36_ = card_grid_bottom;
#line 75 "../src/Dialogs/NewCardDialog.vala"
	_tmp37_ = self->priv->card_cvc_entry;
#line 75 "../src/Dialogs/NewCardDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp36_, (GtkWidget*) _tmp37_);
#line 77 "../src/Dialogs/NewCardDialog.vala"
	_tmp38_ = (GtkGrid*) gtk_grid_new ();
#line 77 "../src/Dialogs/NewCardDialog.vala"
	g_object_ref_sink (_tmp38_);
#line 77 "../src/Dialogs/NewCardDialog.vala"
	card_grid = _tmp38_;
#line 78 "../src/Dialogs/NewCardDialog.vala"
	_tmp39_ = card_grid;
#line 78 "../src/Dialogs/NewCardDialog.vala"
	_tmp40_ = gtk_widget_get_style_context ((GtkWidget*) _tmp39_);
#line 78 "../src/Dialogs/NewCardDialog.vala"
	gtk_style_context_add_class (_tmp40_, GTK_STYLE_CLASS_LINKED);
#line 79 "../src/Dialogs/NewCardDialog.vala"
	_tmp41_ = card_grid;
#line 79 "../src/Dialogs/NewCardDialog.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp41_, GTK_ORIENTATION_VERTICAL);
#line 80 "../src/Dialogs/NewCardDialog.vala"
	_tmp42_ = card_grid;
#line 80 "../src/Dialogs/NewCardDialog.vala"
	_tmp43_ = self->priv->card_number_entry;
#line 80 "../src/Dialogs/NewCardDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp42_, (GtkWidget*) _tmp43_);
#line 81 "../src/Dialogs/NewCardDialog.vala"
	_tmp44_ = card_grid;
#line 81 "../src/Dialogs/NewCardDialog.vala"
	_tmp45_ = card_grid_bottom;
#line 81 "../src/Dialogs/NewCardDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp44_, (GtkWidget*) _tmp45_);
#line 83 "../src/Dialogs/NewCardDialog.vala"
	_tmp46_ = (GtkGrid*) gtk_grid_new ();
#line 83 "../src/Dialogs/NewCardDialog.vala"
	g_object_ref_sink (_tmp46_);
#line 83 "../src/Dialogs/NewCardDialog.vala"
	card_layout = _tmp46_;
#line 84 "../src/Dialogs/NewCardDialog.vala"
	_tmp47_ = card_layout;
#line 84 "../src/Dialogs/NewCardDialog.vala"
	_tmp48_ = gtk_widget_get_style_context ((GtkWidget*) _tmp47_);
#line 84 "../src/Dialogs/NewCardDialog.vala"
	gtk_style_context_add_class (_tmp48_, "login");
#line 85 "../src/Dialogs/NewCardDialog.vala"
	_tmp49_ = card_layout;
#line 85 "../src/Dialogs/NewCardDialog.vala"
	gtk_grid_set_column_spacing (_tmp49_, 12);
#line 86 "../src/Dialogs/NewCardDialog.vala"
	_tmp50_ = card_layout;
#line 86 "../src/Dialogs/NewCardDialog.vala"
	gtk_grid_set_row_spacing (_tmp50_, 6);
#line 87 "../src/Dialogs/NewCardDialog.vala"
	_tmp51_ = card_layout;
#line 87 "../src/Dialogs/NewCardDialog.vala"
	g_object_set ((GtkWidget*) _tmp51_, "margin", 10, NULL);
#line 88 "../src/Dialogs/NewCardDialog.vala"
	_tmp52_ = card_layout;
#line 88 "../src/Dialogs/NewCardDialog.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp52_, 0);
#line 89 "../src/Dialogs/NewCardDialog.vala"
	_tmp53_ = card_layout;
#line 89 "../src/Dialogs/NewCardDialog.vala"
	_tmp54_ = image;
#line 89 "../src/Dialogs/NewCardDialog.vala"
	gtk_grid_attach (_tmp53_, (GtkWidget*) _tmp54_, 0, 0, 1, 2);
#line 90 "../src/Dialogs/NewCardDialog.vala"
	_tmp55_ = card_layout;
#line 90 "../src/Dialogs/NewCardDialog.vala"
	_tmp56_ = primary_label;
#line 90 "../src/Dialogs/NewCardDialog.vala"
	gtk_grid_attach (_tmp55_, (GtkWidget*) _tmp56_, 1, 0, 1, 1);
#line 91 "../src/Dialogs/NewCardDialog.vala"
	_tmp57_ = card_layout;
#line 91 "../src/Dialogs/NewCardDialog.vala"
	_tmp58_ = secondary_label;
#line 91 "../src/Dialogs/NewCardDialog.vala"
	gtk_grid_attach (_tmp57_, (GtkWidget*) _tmp58_, 1, 1, 1, 1);
#line 92 "../src/Dialogs/NewCardDialog.vala"
	_tmp59_ = card_layout;
#line 92 "../src/Dialogs/NewCardDialog.vala"
	_tmp60_ = card_grid;
#line 92 "../src/Dialogs/NewCardDialog.vala"
	gtk_grid_attach (_tmp59_, (GtkWidget*) _tmp60_, 1, 2, 1, 1);
#line 93 "../src/Dialogs/NewCardDialog.vala"
	_tmp61_ = card_layout;
#line 93 "../src/Dialogs/NewCardDialog.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp61_);
#line 95 "../src/Dialogs/NewCardDialog.vala"
	_tmp62_ = gtk_dialog_get_content_area ((GtkDialog*) self);
#line 95 "../src/Dialogs/NewCardDialog.vala"
	_tmp63_ = card_layout;
#line 95 "../src/Dialogs/NewCardDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp62_, (GtkWidget*) _tmp63_);
#line 97 "../src/Dialogs/NewCardDialog.vala"
	_tmp64_ = gtk_dialog_get_action_area ((GtkDialog*) self);
#line 97 "../src/Dialogs/NewCardDialog.vala"
	g_object_set ((GtkWidget*) _tmp64_, "margin", 5, NULL);
#line 99 "../src/Dialogs/NewCardDialog.vala"
	gtk_dialog_add_button ((GtkDialog*) self, _ ("Cancel"), (gint) GTK_RESPONSE_CLOSE);
#line 101 "../src/Dialogs/NewCardDialog.vala"
	_tmp65_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Add Card"), (gint) GTK_RESPONSE_APPLY);
#line 101 "../src/Dialogs/NewCardDialog.vala"
	_tmp66_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp65_, gtk_button_get_type (), GtkButton));
#line 101 "../src/Dialogs/NewCardDialog.vala"
	_g_object_unref0 (self->priv->pay_button);
#line 101 "../src/Dialogs/NewCardDialog.vala"
	self->priv->pay_button = _tmp66_;
#line 102 "../src/Dialogs/NewCardDialog.vala"
	_tmp67_ = self->priv->pay_button;
#line 102 "../src/Dialogs/NewCardDialog.vala"
	_tmp68_ = gtk_widget_get_style_context ((GtkWidget*) _tmp67_);
#line 102 "../src/Dialogs/NewCardDialog.vala"
	gtk_style_context_add_class (_tmp68_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
#line 103 "../src/Dialogs/NewCardDialog.vala"
	_tmp69_ = self->priv->pay_button;
#line 103 "../src/Dialogs/NewCardDialog.vala"
	g_object_set ((GtkWidget*) _tmp69_, "has-default", TRUE, NULL);
#line 104 "../src/Dialogs/NewCardDialog.vala"
	_tmp70_ = self->priv->pay_button;
#line 104 "../src/Dialogs/NewCardDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp70_, FALSE);
#line 106 "../src/Dialogs/NewCardDialog.vala"
	gtk_window_set_deletable ((GtkWindow*) self, FALSE);
#line 107 "../src/Dialogs/NewCardDialog.vala"
	gtk_window_set_resizable ((GtkWindow*) self, FALSE);
#line 109 "../src/Dialogs/NewCardDialog.vala"
	g_signal_connect_object ((GtkDialog*) self, "response", (GCallback) __wallet_new_card_dialog___lambda8__gtk_dialog_response, self, 0);
#line 117 "../src/Dialogs/NewCardDialog.vala"
	_tmp71_ = self->priv->card_number_entry;
#line 117 "../src/Dialogs/NewCardDialog.vala"
	g_signal_connect_object ((GtkEditable*) _tmp71_, "changed", (GCallback) __wallet_new_card_dialog___lambda9__gtk_editable_changed, self, 0);
#line 122 "../src/Dialogs/NewCardDialog.vala"
	_tmp72_ = self->priv->card_expiration_entry;
#line 122 "../src/Dialogs/NewCardDialog.vala"
	g_signal_connect_object ((GtkEditable*) _tmp72_, "changed", (GCallback) __wallet_new_card_dialog___lambda10__gtk_editable_changed, self, 0);
#line 128 "../src/Dialogs/NewCardDialog.vala"
	_tmp73_ = self->priv->card_expiration_entry;
#line 128 "../src/Dialogs/NewCardDialog.vala"
	g_signal_connect_object ((GtkWidget*) _tmp73_, "focus-out-event", (GCallback) __wallet_new_card_dialog___lambda11__gtk_widget_focus_out_event, self, 0);
#line 136 "../src/Dialogs/NewCardDialog.vala"
	_tmp74_ = self->priv->card_cvc_entry;
#line 136 "../src/Dialogs/NewCardDialog.vala"
	g_signal_connect_object ((GtkEditable*) _tmp74_, "changed", (GCallback) __wallet_new_card_dialog___lambda12__gtk_editable_changed, self, 0);
#line 36 "../src/Dialogs/NewCardDialog.vala"
	_g_object_unref0 (card_layout);
#line 36 "../src/Dialogs/NewCardDialog.vala"
	_g_object_unref0 (card_grid);
#line 36 "../src/Dialogs/NewCardDialog.vala"
	_g_object_unref0 (card_grid_bottom);
#line 36 "../src/Dialogs/NewCardDialog.vala"
	_g_object_unref0 (secondary_label);
#line 36 "../src/Dialogs/NewCardDialog.vala"
	_g_object_unref0 (primary_label);
#line 36 "../src/Dialogs/NewCardDialog.vala"
	_g_object_unref0 (image);
#line 36 "../src/Dialogs/NewCardDialog.vala"
	return obj;
#line 1763 "NewCardDialog.c"
}

static void
wallet_new_card_dialog_class_init (WalletNewCardDialogClass * klass,
                                   gpointer klass_data)
{
#line 20 "../src/Dialogs/NewCardDialog.vala"
	wallet_new_card_dialog_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/Dialogs/NewCardDialog.vala"
	g_type_class_adjust_private_offset (klass, &WalletNewCardDialog_private_offset);
#line 20 "../src/Dialogs/NewCardDialog.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_wallet_new_card_dialog_get_property;
#line 20 "../src/Dialogs/NewCardDialog.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_wallet_new_card_dialog_set_property;
#line 20 "../src/Dialogs/NewCardDialog.vala"
	G_OBJECT_CLASS (klass)->constructor = wallet_new_card_dialog_constructor;
#line 20 "../src/Dialogs/NewCardDialog.vala"
	G_OBJECT_CLASS (klass)->finalize = wallet_new_card_dialog_finalize;
#line 20 "../src/Dialogs/NewCardDialog.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WALLET_NEW_CARD_DIALOG_COLLECTION_PROPERTY, wallet_new_card_dialog_properties[WALLET_NEW_CARD_DIALOG_COLLECTION_PROPERTY] = g_param_spec_object ("collection", "collection", "collection", secret_collection_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1784 "NewCardDialog.c"
}

static void
wallet_new_card_dialog_instance_init (WalletNewCardDialog * self,
                                      gpointer klass)
{
#line 20 "../src/Dialogs/NewCardDialog.vala"
	self->priv = wallet_new_card_dialog_get_instance_private (self);
#line 28 "../src/Dialogs/NewCardDialog.vala"
	self->priv->card_valid = FALSE;
#line 29 "../src/Dialogs/NewCardDialog.vala"
	self->priv->expiration_valid = FALSE;
#line 30 "../src/Dialogs/NewCardDialog.vala"
	self->priv->cvc_valid = FALSE;
#line 1799 "NewCardDialog.c"
}

static void
wallet_new_card_dialog_finalize (GObject * obj)
{
	WalletNewCardDialog * self;
#line 20 "../src/Dialogs/NewCardDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WALLET_TYPE_NEW_CARD_DIALOG, WalletNewCardDialog);
#line 21 "../src/Dialogs/NewCardDialog.vala"
	_g_object_unref0 (self->priv->_collection);
#line 23 "../src/Dialogs/NewCardDialog.vala"
	_g_object_unref0 (self->priv->pay_button);
#line 24 "../src/Dialogs/NewCardDialog.vala"
	_g_object_unref0 (self->priv->card_expiration_entry);
#line 25 "../src/Dialogs/NewCardDialog.vala"
	_g_object_unref0 (self->priv->card_cvc_entry);
#line 26 "../src/Dialogs/NewCardDialog.vala"
	_g_object_unref0 (self->priv->card_number_entry);
#line 20 "../src/Dialogs/NewCardDialog.vala"
	G_OBJECT_CLASS (wallet_new_card_dialog_parent_class)->finalize (obj);
#line 1820 "NewCardDialog.c"
}

static GType
wallet_new_card_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WalletNewCardDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) wallet_new_card_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WalletNewCardDialog), 0, (GInstanceInitFunc) wallet_new_card_dialog_instance_init, NULL };
	GType wallet_new_card_dialog_type_id;
	wallet_new_card_dialog_type_id = g_type_register_static (gtk_dialog_get_type (), "WalletNewCardDialog", &g_define_type_info, 0);
	WalletNewCardDialog_private_offset = g_type_add_instance_private (wallet_new_card_dialog_type_id, sizeof (WalletNewCardDialogPrivate));
	return wallet_new_card_dialog_type_id;
}

GType
wallet_new_card_dialog_get_type (void)
{
	static volatile gsize wallet_new_card_dialog_type_id__once = 0;
	if (g_once_init_enter (&wallet_new_card_dialog_type_id__once)) {
		GType wallet_new_card_dialog_type_id;
		wallet_new_card_dialog_type_id = wallet_new_card_dialog_get_type_once ();
		g_once_init_leave (&wallet_new_card_dialog_type_id__once, wallet_new_card_dialog_type_id);
	}
	return wallet_new_card_dialog_type_id__once;
}

static void
_vala_wallet_new_card_dialog_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	WalletNewCardDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WALLET_TYPE_NEW_CARD_DIALOG, WalletNewCardDialog);
#line 20 "../src/Dialogs/NewCardDialog.vala"
	switch (property_id) {
#line 20 "../src/Dialogs/NewCardDialog.vala"
		case WALLET_NEW_CARD_DIALOG_COLLECTION_PROPERTY:
#line 20 "../src/Dialogs/NewCardDialog.vala"
		g_value_set_object (value, wallet_new_card_dialog_get_collection (self));
#line 20 "../src/Dialogs/NewCardDialog.vala"
		break;
#line 1861 "NewCardDialog.c"
		default:
#line 20 "../src/Dialogs/NewCardDialog.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/Dialogs/NewCardDialog.vala"
		break;
#line 1867 "NewCardDialog.c"
	}
}

static void
_vala_wallet_new_card_dialog_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	WalletNewCardDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WALLET_TYPE_NEW_CARD_DIALOG, WalletNewCardDialog);
#line 20 "../src/Dialogs/NewCardDialog.vala"
	switch (property_id) {
#line 20 "../src/Dialogs/NewCardDialog.vala"
		case WALLET_NEW_CARD_DIALOG_COLLECTION_PROPERTY:
#line 20 "../src/Dialogs/NewCardDialog.vala"
		wallet_new_card_dialog_set_collection (self, g_value_get_object (value));
#line 20 "../src/Dialogs/NewCardDialog.vala"
		break;
#line 1887 "NewCardDialog.c"
		default:
#line 20 "../src/Dialogs/NewCardDialog.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/Dialogs/NewCardDialog.vala"
		break;
#line 1893 "NewCardDialog.c"
	}
}

