/* Plug.c generated by valac 0.56.12, the Vala compiler
 * generated from Plug.vala, do not modify */

/*
 * Copyright 2018-2020 elementary, Inc
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Cassidy James Blaede <c@ssidyjam.es>
 */

#include "io.elementary.switchboard.wallet.h"
#include <switchboard.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gee.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <gmodule.h>

enum  {
	WALLET_PLUG_0_PROPERTY,
	WALLET_PLUG_NUM_PROPERTIES
};
static GParamSpec* wallet_plug_properties[WALLET_PLUG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _WalletPlugSearchData WalletPlugSearchData;

struct _WalletPlugPrivate {
	WalletMainView* main_view;
};

struct _WalletPlugSearchData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	WalletPlug* self;
	gchar* search;
	GeeTreeMap* result;
	GeeTreeMap* search_results;
	GCompareFunc _tmp0_;
	GEqualFunc _tmp1_;
	GeeTreeMap* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
};

static gint WalletPlug_private_offset;
static gpointer wallet_plug_parent_class = NULL;

static GtkWidget* wallet_plug_real_get_widget (SwitchboardPlug* base);
static void wallet_plug_real_shown (SwitchboardPlug* base);
static void wallet_plug_real_hidden (SwitchboardPlug* base);
static void wallet_plug_real_search_callback (SwitchboardPlug* base,
                                       const gchar* location);
static void wallet_plug_real_search_data_free (gpointer _data);
static void wallet_plug_real_search (SwitchboardPlug* base,
                              const gchar* search,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_);
static gboolean wallet_plug_real_search_co (WalletPlugSearchData* _data_);
static void wallet_plug_finalize (GObject * obj);
static GType wallet_plug_get_type_once (void);

static inline gpointer
wallet_plug_get_instance_private (WalletPlug* self)
{
	return G_STRUCT_MEMBER_P (self, WalletPlug_private_offset);
}

WalletPlug*
wallet_plug_construct (GType object_type)
{
	WalletPlug * self = NULL;
	GeeTreeMap* settings = NULL;
	GeeTreeMap* _tmp0_;
#line 24 "../src/Plug.vala"
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
#line 25 "../src/Plug.vala"
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
#line 27 "../src/Plug.vala"
	_tmp0_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 27 "../src/Plug.vala"
	settings = _tmp0_;
#line 28 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) settings, "personal/payments", NULL);
#line 29 "../src/Plug.vala"
	self = (WalletPlug*) g_object_new (object_type, "category", SWITCHBOARD_PLUG_CATEGORY_PERSONAL, "code-name", "io.elementary.switchboard.wallet", "display-name", _ ("Wallet"), "description", _ ("Manage payment methods"), "icon", "io.elementary.switchboard.wallet", "supported-settings", settings, NULL);
#line 23 "../src/Plug.vala"
	_g_object_unref0 (settings);
#line 23 "../src/Plug.vala"
	return self;
#line 128 "Plug.c"
}

WalletPlug*
wallet_plug_new (void)
{
#line 23 "../src/Plug.vala"
	return wallet_plug_construct (WALLET_TYPE_PLUG);
#line 136 "Plug.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 45 "../src/Plug.vala"
	return self ? g_object_ref (self) : NULL;
#line 144 "Plug.c"
}

static GtkWidget*
wallet_plug_real_get_widget (SwitchboardPlug* base)
{
	WalletPlug * self;
	WalletMainView* _tmp0_;
	WalletMainView* _tmp3_;
	GtkWidget* _tmp4_;
	GtkWidget* result;
#line 39 "../src/Plug.vala"
	self = (WalletPlug*) base;
#line 40 "../src/Plug.vala"
	_tmp0_ = self->priv->main_view;
#line 40 "../src/Plug.vala"
	if (_tmp0_ == NULL) {
#line 161 "Plug.c"
		WalletMainView* _tmp1_;
		WalletMainView* _tmp2_;
#line 41 "../src/Plug.vala"
		_tmp1_ = wallet_main_view_new ();
#line 41 "../src/Plug.vala"
		g_object_ref_sink (_tmp1_);
#line 41 "../src/Plug.vala"
		_g_object_unref0 (self->priv->main_view);
#line 41 "../src/Plug.vala"
		self->priv->main_view = _tmp1_;
#line 42 "../src/Plug.vala"
		_tmp2_ = self->priv->main_view;
#line 42 "../src/Plug.vala"
		g_object_set ((GtkWidget*) _tmp2_, "margin", 12, NULL);
#line 176 "Plug.c"
	}
#line 45 "../src/Plug.vala"
	_tmp3_ = self->priv->main_view;
#line 45 "../src/Plug.vala"
	_tmp4_ = _g_object_ref0 ((GtkWidget*) _tmp3_);
#line 45 "../src/Plug.vala"
	result = _tmp4_;
#line 45 "../src/Plug.vala"
	return result;
#line 186 "Plug.c"
}

static void
wallet_plug_real_shown (SwitchboardPlug* base)
{
	WalletPlug * self;
#line 48 "../src/Plug.vala"
	self = (WalletPlug*) base;
#line 195 "Plug.c"
}

static void
wallet_plug_real_hidden (SwitchboardPlug* base)
{
	WalletPlug * self;
#line 52 "../src/Plug.vala"
	self = (WalletPlug*) base;
#line 204 "Plug.c"
}

static void
wallet_plug_real_search_callback (SwitchboardPlug* base,
                                  const gchar* location)
{
	WalletPlug * self;
#line 56 "../src/Plug.vala"
	self = (WalletPlug*) base;
#line 56 "../src/Plug.vala"
	g_return_if_fail (location != NULL);
#line 216 "Plug.c"
}

static void
wallet_plug_real_search_data_free (gpointer _data)
{
	WalletPlugSearchData* _data_;
	_data_ = _data;
#line 20 "../src/Plug.vala"
	_g_free0 (_data_->search);
#line 20 "../src/Plug.vala"
	_g_object_unref0 (_data_->result);
#line 20 "../src/Plug.vala"
	_g_object_unref0 (_data_->self);
#line 20 "../src/Plug.vala"
	g_slice_free (WalletPlugSearchData, _data_);
#line 232 "Plug.c"
}

static void
wallet_plug_real_search (SwitchboardPlug* base,
                         const gchar* search,
                         GAsyncReadyCallback _callback_,
                         gpointer _user_data_)
{
	WalletPlug * self;
	WalletPlugSearchData* _data_;
	WalletPlug* _tmp0_;
	gchar* _tmp1_;
#line 20 "../src/Plug.vala"
	g_return_if_fail (search != NULL);
#line 20 "../src/Plug.vala"
	self = (WalletPlug*) base;
#line 20 "../src/Plug.vala"
	_data_ = g_slice_new0 (WalletPlugSearchData);
#line 20 "../src/Plug.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 20 "../src/Plug.vala"
	g_task_set_task_data (_data_->_async_result, _data_, wallet_plug_real_search_data_free);
#line 20 "../src/Plug.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 20 "../src/Plug.vala"
	_data_->self = _tmp0_;
#line 20 "../src/Plug.vala"
	_tmp1_ = g_strdup (search);
#line 20 "../src/Plug.vala"
	_g_free0 (_data_->search);
#line 20 "../src/Plug.vala"
	_data_->search = _tmp1_;
#line 20 "../src/Plug.vala"
	wallet_plug_real_search_co (_data_);
#line 267 "Plug.c"
}

static GeeTreeMap*
wallet_plug_search_finish (SwitchboardPlug* base,
                           GAsyncResult* _res_)
{
	GeeTreeMap* result;
	WalletPlugSearchData* _data_;
#line 20 "../src/Plug.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 20 "../src/Plug.vala"
	result = _data_->result;
#line 20 "../src/Plug.vala"
	_data_->result = NULL;
#line 20 "../src/Plug.vala"
	return result;
#line 284 "Plug.c"
}

static gboolean
wallet_plug_real_search_co (WalletPlugSearchData* _data_)
{
#line 60 "../src/Plug.vala"
	switch (_data_->_state_) {
#line 60 "../src/Plug.vala"
		case 0:
#line 294 "Plug.c"
		goto _state_0;
		default:
#line 60 "../src/Plug.vala"
		g_assert_not_reached ();
#line 299 "Plug.c"
	}
	_state_0:
#line 61 "../src/Plug.vala"
	_data_->_tmp0_ = ((GCompareFunc) g_strcmp0);
#line 61 "../src/Plug.vala"
	_data_->_tmp1_ = g_str_equal;
#line 61 "../src/Plug.vala"
	_data_->_tmp2_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, (GCompareDataFunc) _data_->_tmp0_, NULL, NULL, (GeeEqualDataFunc) _data_->_tmp1_, NULL, NULL);
#line 61 "../src/Plug.vala"
	_data_->search_results = _data_->_tmp2_;
#line 65 "../src/Plug.vala"
	_data_->_tmp3_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 65 "../src/Plug.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 65 "../src/Plug.vala"
	_data_->_tmp5_ = g_strdup_printf ("%s → %s", _data_->_tmp4_, _ ("Credit Card"));
#line 65 "../src/Plug.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 65 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp6_, "");
#line 65 "../src/Plug.vala"
	_g_free0 (_data_->_tmp6_);
#line 66 "../src/Plug.vala"
	_data_->_tmp7_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 66 "../src/Plug.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 66 "../src/Plug.vala"
	_data_->_tmp9_ = g_strdup_printf ("%s → %s", _data_->_tmp8_, _ ("Debit Card"));
#line 66 "../src/Plug.vala"
	_data_->_tmp10_ = _data_->_tmp9_;
#line 66 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp10_, "");
#line 66 "../src/Plug.vala"
	_g_free0 (_data_->_tmp10_);
#line 67 "../src/Plug.vala"
	_data_->_tmp11_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 67 "../src/Plug.vala"
	_data_->_tmp12_ = _data_->_tmp11_;
#line 67 "../src/Plug.vala"
	_data_->_tmp13_ = g_strdup_printf ("%s → %s", _data_->_tmp12_, _ ("Payments"));
#line 67 "../src/Plug.vala"
	_data_->_tmp14_ = _data_->_tmp13_;
#line 67 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp14_, "");
#line 67 "../src/Plug.vala"
	_g_free0 (_data_->_tmp14_);
#line 68 "../src/Plug.vala"
	_data_->_tmp15_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 68 "../src/Plug.vala"
	_data_->_tmp16_ = _data_->_tmp15_;
#line 68 "../src/Plug.vala"
	_data_->_tmp17_ = g_strdup_printf ("%s → %s", _data_->_tmp16_, _ ("Wallet"));
#line 68 "../src/Plug.vala"
	_data_->_tmp18_ = _data_->_tmp17_;
#line 68 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp18_, "");
#line 68 "../src/Plug.vala"
	_g_free0 (_data_->_tmp18_);
#line 69 "../src/Plug.vala"
	_data_->_tmp19_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 69 "../src/Plug.vala"
	_data_->_tmp20_ = _data_->_tmp19_;
#line 69 "../src/Plug.vala"
	_data_->_tmp21_ = g_strdup_printf ("%s → %s", _data_->_tmp20_, _ ("Fund"));
#line 69 "../src/Plug.vala"
	_data_->_tmp22_ = _data_->_tmp21_;
#line 69 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp22_, "");
#line 69 "../src/Plug.vala"
	_g_free0 (_data_->_tmp22_);
#line 70 "../src/Plug.vala"
	_data_->result = _data_->search_results;
#line 70 "../src/Plug.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 70 "../src/Plug.vala"
	if (_data_->_state_ != 0) {
#line 70 "../src/Plug.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 70 "../src/Plug.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 380 "Plug.c"
		}
	}
#line 70 "../src/Plug.vala"
	g_object_unref (_data_->_async_result);
#line 70 "../src/Plug.vala"
	return FALSE;
#line 387 "Plug.c"
}

static void
wallet_plug_class_init (WalletPlugClass * klass,
                        gpointer klass_data)
{
#line 20 "../src/Plug.vala"
	wallet_plug_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/Plug.vala"
	g_type_class_adjust_private_offset (klass, &WalletPlug_private_offset);
#line 20 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->get_widget = (GtkWidget* (*) (SwitchboardPlug*)) wallet_plug_real_get_widget;
#line 20 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->shown = (void (*) (SwitchboardPlug*)) wallet_plug_real_shown;
#line 20 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->hidden = (void (*) (SwitchboardPlug*)) wallet_plug_real_hidden;
#line 20 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search_callback = (void (*) (SwitchboardPlug*, const gchar*)) wallet_plug_real_search_callback;
#line 20 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search = (void (*) (SwitchboardPlug*, const gchar*, GAsyncReadyCallback, gpointer)) wallet_plug_real_search;
#line 20 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search_finish = (GeeTreeMap* (*) (SwitchboardPlug*, GAsyncResult*)) wallet_plug_search_finish;
#line 20 "../src/Plug.vala"
	G_OBJECT_CLASS (klass)->finalize = wallet_plug_finalize;
#line 412 "Plug.c"
}

static void
wallet_plug_instance_init (WalletPlug * self,
                           gpointer klass)
{
#line 20 "../src/Plug.vala"
	self->priv = wallet_plug_get_instance_private (self);
#line 421 "Plug.c"
}

static void
wallet_plug_finalize (GObject * obj)
{
	WalletPlug * self;
#line 20 "../src/Plug.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WALLET_TYPE_PLUG, WalletPlug);
#line 21 "../src/Plug.vala"
	_g_object_unref0 (self->priv->main_view);
#line 20 "../src/Plug.vala"
	G_OBJECT_CLASS (wallet_plug_parent_class)->finalize (obj);
#line 434 "Plug.c"
}

static GType
wallet_plug_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WalletPlugClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) wallet_plug_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WalletPlug), 0, (GInstanceInitFunc) wallet_plug_instance_init, NULL };
	GType wallet_plug_type_id;
	wallet_plug_type_id = g_type_register_static (SWITCHBOARD_TYPE_PLUG, "WalletPlug", &g_define_type_info, 0);
	WalletPlug_private_offset = g_type_add_instance_private (wallet_plug_type_id, sizeof (WalletPlugPrivate));
	return wallet_plug_type_id;
}

GType
wallet_plug_get_type (void)
{
	static volatile gsize wallet_plug_type_id__once = 0;
	if (g_once_init_enter (&wallet_plug_type_id__once)) {
		GType wallet_plug_type_id;
		wallet_plug_type_id = wallet_plug_get_type_once ();
		g_once_init_leave (&wallet_plug_type_id__once, wallet_plug_type_id);
	}
	return wallet_plug_type_id__once;
}

SwitchboardPlug*
get_plug (GModule* module)
{
	WalletPlug* plug = NULL;
	WalletPlug* _tmp0_;
	SwitchboardPlug* result;
#line 74 "../src/Plug.vala"
	g_return_val_if_fail (module != NULL, NULL);
#line 75 "../src/Plug.vala"
	_tmp0_ = wallet_plug_new ();
#line 75 "../src/Plug.vala"
	plug = _tmp0_;
#line 76 "../src/Plug.vala"
	result = (SwitchboardPlug*) plug;
#line 76 "../src/Plug.vala"
	return result;
#line 475 "Plug.c"
}

