/* CardNumberEntry.c generated by valac 0.56.12, the Vala compiler
 * generated from CardNumberEntry.vala, do not modify */

/*-
 * Copyright 2018-2020 elementary, Inc. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "io.elementary.switchboard.wallet.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>

enum  {
	WALLET_CARD_NUMBER_ENTRY_0_PROPERTY,
	WALLET_CARD_NUMBER_ENTRY_CARD_NUMBER_PROPERTY,
	WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_PROPERTY,
	WALLET_CARD_NUMBER_ENTRY_NUM_PROPERTIES
};
static GParamSpec* wallet_card_number_entry_properties[WALLET_CARD_NUMBER_ENTRY_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

struct _WalletCardNumberEntryPrivate {
	gchar* _card_number;
	WalletCardNumberEntryCardType _card_type;
	guint timeout;
	gboolean insertion;
};

struct _Block1Data {
	int _ref_count_;
	WalletCardNumberEntry* self;
	gint end_offset;
	gint new_offset;
};

static gint WalletCardNumberEntry_private_offset;
static gpointer wallet_card_number_entry_parent_class = NULL;

static void wallet_card_number_entry_update_number (WalletCardNumberEntry* self);
static void wallet_card_number_entry_detect_card (WalletCardNumberEntry* self);
static void wallet_card_number_entry_set_card_type (WalletCardNumberEntry* self,
                                             WalletCardNumberEntryCardType value);
static void wallet_card_number_entry_change_card_icon (WalletCardNumberEntry* self);
static gint* wallet_card_number_entry_get_card_pattern (WalletCardNumberEntry* self,
                                                 gint* result_length1);
static gint wallet_card_number_entry_get_card_max_length (WalletCardNumberEntry* self);
static GObject * wallet_card_number_entry_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties);
static void _wallet_card_number_entry___lambda4_ (WalletCardNumberEntry* self,
                                           gint start_pos,
                                           gint end_pos);
static void __wallet_card_number_entry___lambda4__gtk_editable_delete_text (GtkEditable* _sender,
                                                                     gint start_pos,
                                                                     gint end_pos,
                                                                     gpointer self);
static void _wallet_card_number_entry___lambda5_ (WalletCardNumberEntry* self,
                                           const gchar* start_pos,
                                           gint end_pos,
                                           gint* pos);
static void __wallet_card_number_entry___lambda5__gtk_editable_insert_text (GtkEditable* _sender,
                                                                     const gchar* new_text,
                                                                     gint new_text_length,
                                                                     gint* position,
                                                                     gpointer self);
static void _wallet_card_number_entry___lambda6_ (WalletCardNumberEntry* self);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean _vala_int_array_contains (gint * stack,
                                   gssize stack_length,
                                   const gint needle);
static gboolean ___lambda7_ (Block1Data* _data1_);
static gboolean ____lambda7__gsource_func (gpointer self);
static void __wallet_card_number_entry___lambda6__gtk_editable_changed (GtkEditable* _sender,
                                                                 gpointer self);
static void wallet_card_number_entry_finalize (GObject * obj);
static GType wallet_card_number_entry_get_type_once (void);
static void _vala_wallet_card_number_entry_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_wallet_card_number_entry_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);

static inline gpointer
wallet_card_number_entry_get_instance_private (WalletCardNumberEntry* self)
{
	return G_STRUCT_MEMBER_P (self, WalletCardNumberEntry_private_offset);
}

gchar*
wallet_card_number_entry_card_type_to_string (WalletCardNumberEntryCardType self)
{
	gchar* result;
#line 35 "../src/Widgets/CardNumberEntry.vala"
	switch (self) {
#line 35 "../src/Widgets/CardNumberEntry.vala"
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_VISA:
#line 126 "CardNumberEntry.c"
		{
			gchar* _tmp0_;
#line 37 "../src/Widgets/CardNumberEntry.vala"
			_tmp0_ = g_strdup ("Visa");
#line 37 "../src/Widgets/CardNumberEntry.vala"
			result = _tmp0_;
#line 37 "../src/Widgets/CardNumberEntry.vala"
			return result;
#line 135 "CardNumberEntry.c"
		}
#line 35 "../src/Widgets/CardNumberEntry.vala"
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_MASTERCARD:
#line 139 "CardNumberEntry.c"
		{
			gchar* _tmp1_;
#line 39 "../src/Widgets/CardNumberEntry.vala"
			_tmp1_ = g_strdup ("MasterCard");
#line 39 "../src/Widgets/CardNumberEntry.vala"
			result = _tmp1_;
#line 39 "../src/Widgets/CardNumberEntry.vala"
			return result;
#line 148 "CardNumberEntry.c"
		}
#line 35 "../src/Widgets/CardNumberEntry.vala"
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_AMERICAN_EXPRESS:
#line 152 "CardNumberEntry.c"
		{
			gchar* _tmp2_;
#line 41 "../src/Widgets/CardNumberEntry.vala"
			_tmp2_ = g_strdup ("American Express");
#line 41 "../src/Widgets/CardNumberEntry.vala"
			result = _tmp2_;
#line 41 "../src/Widgets/CardNumberEntry.vala"
			return result;
#line 161 "CardNumberEntry.c"
		}
#line 35 "../src/Widgets/CardNumberEntry.vala"
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_DISCOVER:
#line 165 "CardNumberEntry.c"
		{
			gchar* _tmp3_;
#line 43 "../src/Widgets/CardNumberEntry.vala"
			_tmp3_ = g_strdup ("Discover");
#line 43 "../src/Widgets/CardNumberEntry.vala"
			result = _tmp3_;
#line 43 "../src/Widgets/CardNumberEntry.vala"
			return result;
#line 174 "CardNumberEntry.c"
		}
#line 35 "../src/Widgets/CardNumberEntry.vala"
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_DINERS_CLUB:
#line 178 "CardNumberEntry.c"
		{
			gchar* _tmp4_;
#line 45 "../src/Widgets/CardNumberEntry.vala"
			_tmp4_ = g_strdup ("Diners Club");
#line 45 "../src/Widgets/CardNumberEntry.vala"
			result = _tmp4_;
#line 45 "../src/Widgets/CardNumberEntry.vala"
			return result;
#line 187 "CardNumberEntry.c"
		}
#line 35 "../src/Widgets/CardNumberEntry.vala"
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_JCB:
#line 191 "CardNumberEntry.c"
		{
			gchar* _tmp5_;
#line 47 "../src/Widgets/CardNumberEntry.vala"
			_tmp5_ = g_strdup ("JCB");
#line 47 "../src/Widgets/CardNumberEntry.vala"
			result = _tmp5_;
#line 47 "../src/Widgets/CardNumberEntry.vala"
			return result;
#line 200 "CardNumberEntry.c"
		}
#line 35 "../src/Widgets/CardNumberEntry.vala"
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_UNIONPAY:
#line 204 "CardNumberEntry.c"
		{
			gchar* _tmp6_;
#line 49 "../src/Widgets/CardNumberEntry.vala"
			_tmp6_ = g_strdup ("UnionPay");
#line 49 "../src/Widgets/CardNumberEntry.vala"
			result = _tmp6_;
#line 49 "../src/Widgets/CardNumberEntry.vala"
			return result;
#line 213 "CardNumberEntry.c"
		}
		default:
		{
			gchar* _tmp7_;
#line 51 "../src/Widgets/CardNumberEntry.vala"
			_tmp7_ = g_strdup ("Unknown");
#line 51 "../src/Widgets/CardNumberEntry.vala"
			result = _tmp7_;
#line 51 "../src/Widgets/CardNumberEntry.vala"
			return result;
#line 224 "CardNumberEntry.c"
		}
	}
}

static GType
wallet_card_number_entry_card_type_get_type_once (void)
{
	static const GEnumValue values[] = {{WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_UNKNOWN, "WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_UNKNOWN", "unknown"}, {WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_VISA, "WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_VISA", "visa"}, {WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_MASTERCARD, "WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_MASTERCARD", "mastercard"}, {WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_AMERICAN_EXPRESS, "WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_AMERICAN_EXPRESS", "american-express"}, {WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_DISCOVER, "WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_DISCOVER", "discover"}, {WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_DINERS_CLUB, "WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_DINERS_CLUB", "diners-club"}, {WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_JCB, "WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_JCB", "jcb"}, {WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_UNIONPAY, "WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_UNIONPAY", "unionpay"}, {0, NULL, NULL}};
	GType wallet_card_number_entry_card_type_type_id;
	wallet_card_number_entry_card_type_type_id = g_enum_register_static ("WalletCardNumberEntryCardType", values);
	return wallet_card_number_entry_card_type_type_id;
}

GType
wallet_card_number_entry_card_type_get_type (void)
{
	static volatile gsize wallet_card_number_entry_card_type_type_id__once = 0;
	if (g_once_init_enter (&wallet_card_number_entry_card_type_type_id__once)) {
		GType wallet_card_number_entry_card_type_type_id;
		wallet_card_number_entry_card_type_type_id = wallet_card_number_entry_card_type_get_type_once ();
		g_once_init_leave (&wallet_card_number_entry_card_type_type_id__once, wallet_card_number_entry_card_type_type_id);
	}
	return wallet_card_number_entry_card_type_type_id__once;
}

static void
wallet_card_number_entry_update_number (WalletCardNumberEntry* self)
{
	GError* _inner_error0_ = NULL;
#line 103 "../src/Widgets/CardNumberEntry.vala"
	g_return_if_fail (self != NULL);
#line 256 "CardNumberEntry.c"
	{
		GRegex* regex = NULL;
		GRegex* _tmp0_;
		gchar* _tmp1_ = NULL;
		GRegex* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 105 "../src/Widgets/CardNumberEntry.vala"
		_tmp0_ = g_regex_new ("[^0-9]", 0, 0, &_inner_error0_);
#line 105 "../src/Widgets/CardNumberEntry.vala"
		regex = _tmp0_;
#line 105 "../src/Widgets/CardNumberEntry.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 271 "CardNumberEntry.c"
			goto __catch0_g_error;
		}
#line 106 "../src/Widgets/CardNumberEntry.vala"
		_tmp2_ = regex;
#line 106 "../src/Widgets/CardNumberEntry.vala"
		_tmp3_ = gtk_entry_get_text ((GtkEntry*) self);
#line 106 "../src/Widgets/CardNumberEntry.vala"
		_tmp4_ = _tmp3_;
#line 106 "../src/Widgets/CardNumberEntry.vala"
		_tmp5_ = g_regex_replace_literal (_tmp2_, _tmp4_, (gssize) -1, 0, "", 0, &_inner_error0_);
#line 106 "../src/Widgets/CardNumberEntry.vala"
		_tmp1_ = _tmp5_;
#line 106 "../src/Widgets/CardNumberEntry.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 106 "../src/Widgets/CardNumberEntry.vala"
			_g_regex_unref0 (regex);
#line 288 "CardNumberEntry.c"
			goto __catch0_g_error;
		}
#line 106 "../src/Widgets/CardNumberEntry.vala"
		wallet_card_number_entry_set_card_number (self, _tmp1_);
#line 104 "../src/Widgets/CardNumberEntry.vala"
		_g_free0 (_tmp1_);
#line 104 "../src/Widgets/CardNumberEntry.vala"
		_g_regex_unref0 (regex);
#line 297 "CardNumberEntry.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
#line 104 "../src/Widgets/CardNumberEntry.vala"
		e = _inner_error0_;
#line 104 "../src/Widgets/CardNumberEntry.vala"
		_inner_error0_ = NULL;
#line 108 "../src/Widgets/CardNumberEntry.vala"
		_tmp6_ = e;
#line 108 "../src/Widgets/CardNumberEntry.vala"
		_tmp7_ = _tmp6_->message;
#line 108 "../src/Widgets/CardNumberEntry.vala"
		g_critical ("CardNumberEntry.vala:108: %s", _tmp7_);
#line 109 "../src/Widgets/CardNumberEntry.vala"
		_tmp8_ = gtk_entry_get_text ((GtkEntry*) self);
#line 109 "../src/Widgets/CardNumberEntry.vala"
		_tmp9_ = _tmp8_;
#line 109 "../src/Widgets/CardNumberEntry.vala"
		wallet_card_number_entry_set_card_number (self, _tmp9_);
#line 104 "../src/Widgets/CardNumberEntry.vala"
		_g_error_free0 (e);
#line 325 "CardNumberEntry.c"
	}
	__finally0:
#line 104 "../src/Widgets/CardNumberEntry.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 104 "../src/Widgets/CardNumberEntry.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 104 "../src/Widgets/CardNumberEntry.vala"
		g_clear_error (&_inner_error0_);
#line 104 "../src/Widgets/CardNumberEntry.vala"
		return;
#line 336 "CardNumberEntry.c"
	}
}

static void
wallet_card_number_entry_detect_card (WalletCardNumberEntry* self)
{
	gchar* number = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
#line 113 "../src/Widgets/CardNumberEntry.vala"
	g_return_if_fail (self != NULL);
#line 114 "../src/Widgets/CardNumberEntry.vala"
	_tmp0_ = self->priv->_card_number;
#line 114 "../src/Widgets/CardNumberEntry.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 114 "../src/Widgets/CardNumberEntry.vala"
	number = _tmp1_;
#line 116 "../src/Widgets/CardNumberEntry.vala"
	_tmp2_ = number;
#line 116 "../src/Widgets/CardNumberEntry.vala"
	if (g_str_has_prefix (_tmp2_, "4")) {
#line 117 "../src/Widgets/CardNumberEntry.vala"
		wallet_card_number_entry_set_card_type (self, WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_VISA);
#line 118 "../src/Widgets/CardNumberEntry.vala"
		_g_free0 (number);
#line 118 "../src/Widgets/CardNumberEntry.vala"
		return;
#line 372 "CardNumberEntry.c"
	}
#line 121 "../src/Widgets/CardNumberEntry.vala"
	_tmp3_ = number;
#line 121 "../src/Widgets/CardNumberEntry.vala"
	if (g_regex_match_simple ("^(?:5[1-5]|222[1-9]|22[3-9]|2[3-6]|27[01]|2720)", _tmp3_, 0, 0)) {
#line 122 "../src/Widgets/CardNumberEntry.vala"
		wallet_card_number_entry_set_card_type (self, WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_MASTERCARD);
#line 123 "../src/Widgets/CardNumberEntry.vala"
		_g_free0 (number);
#line 123 "../src/Widgets/CardNumberEntry.vala"
		return;
#line 384 "CardNumberEntry.c"
	}
#line 126 "../src/Widgets/CardNumberEntry.vala"
	_tmp5_ = number;
#line 126 "../src/Widgets/CardNumberEntry.vala"
	if (g_str_has_prefix (_tmp5_, "34")) {
#line 126 "../src/Widgets/CardNumberEntry.vala"
		_tmp4_ = TRUE;
#line 392 "CardNumberEntry.c"
	} else {
		const gchar* _tmp6_;
#line 126 "../src/Widgets/CardNumberEntry.vala"
		_tmp6_ = number;
#line 126 "../src/Widgets/CardNumberEntry.vala"
		_tmp4_ = g_str_has_prefix (_tmp6_, "37");
#line 399 "CardNumberEntry.c"
	}
#line 126 "../src/Widgets/CardNumberEntry.vala"
	if (_tmp4_) {
#line 127 "../src/Widgets/CardNumberEntry.vala"
		wallet_card_number_entry_set_card_type (self, WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_AMERICAN_EXPRESS);
#line 128 "../src/Widgets/CardNumberEntry.vala"
		_g_free0 (number);
#line 128 "../src/Widgets/CardNumberEntry.vala"
		return;
#line 409 "CardNumberEntry.c"
	}
#line 131 "../src/Widgets/CardNumberEntry.vala"
	_tmp7_ = number;
#line 131 "../src/Widgets/CardNumberEntry.vala"
	if (g_str_has_prefix (_tmp7_, "62")) {
#line 132 "../src/Widgets/CardNumberEntry.vala"
		wallet_card_number_entry_set_card_type (self, WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_UNIONPAY);
#line 133 "../src/Widgets/CardNumberEntry.vala"
		_g_free0 (number);
#line 133 "../src/Widgets/CardNumberEntry.vala"
		return;
#line 421 "CardNumberEntry.c"
	}
#line 136 "../src/Widgets/CardNumberEntry.vala"
	_tmp8_ = number;
#line 136 "../src/Widgets/CardNumberEntry.vala"
	if (g_regex_match_simple ("^(2[01]([2-4]|1[4-9])|36|30([0-5]|95)|3[89])", _tmp8_, 0, 0)) {
#line 137 "../src/Widgets/CardNumberEntry.vala"
		wallet_card_number_entry_set_card_type (self, WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_DINERS_CLUB);
#line 138 "../src/Widgets/CardNumberEntry.vala"
		_g_free0 (number);
#line 138 "../src/Widgets/CardNumberEntry.vala"
		return;
#line 433 "CardNumberEntry.c"
	}
#line 141 "../src/Widgets/CardNumberEntry.vala"
	_tmp9_ = number;
#line 141 "../src/Widgets/CardNumberEntry.vala"
	if (g_regex_match_simple ("^(6011|6[45])", _tmp9_, 0, 0)) {
#line 142 "../src/Widgets/CardNumberEntry.vala"
		wallet_card_number_entry_set_card_type (self, WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_DISCOVER);
#line 143 "../src/Widgets/CardNumberEntry.vala"
		_g_free0 (number);
#line 143 "../src/Widgets/CardNumberEntry.vala"
		return;
#line 445 "CardNumberEntry.c"
	}
#line 146 "../src/Widgets/CardNumberEntry.vala"
	_tmp10_ = number;
#line 146 "../src/Widgets/CardNumberEntry.vala"
	if (g_regex_match_simple ("^(35([3-8]|2[89]))", _tmp10_, 0, 0)) {
#line 147 "../src/Widgets/CardNumberEntry.vala"
		wallet_card_number_entry_set_card_type (self, WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_JCB);
#line 148 "../src/Widgets/CardNumberEntry.vala"
		_g_free0 (number);
#line 148 "../src/Widgets/CardNumberEntry.vala"
		return;
#line 457 "CardNumberEntry.c"
	}
#line 151 "../src/Widgets/CardNumberEntry.vala"
	wallet_card_number_entry_set_card_type (self, WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_UNKNOWN);
#line 113 "../src/Widgets/CardNumberEntry.vala"
	_g_free0 (number);
#line 463 "CardNumberEntry.c"
}

static void
wallet_card_number_entry_change_card_icon (WalletCardNumberEntry* self)
{
	WalletCardNumberEntryCardType _tmp0_;
#line 154 "../src/Widgets/CardNumberEntry.vala"
	g_return_if_fail (self != NULL);
#line 155 "../src/Widgets/CardNumberEntry.vala"
	_tmp0_ = self->priv->_card_type;
#line 155 "../src/Widgets/CardNumberEntry.vala"
	switch (_tmp0_) {
#line 155 "../src/Widgets/CardNumberEntry.vala"
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_VISA:
#line 478 "CardNumberEntry.c"
		{
			GThemedIcon* _tmp1_;
			GThemedIcon* _tmp2_;
#line 157 "../src/Widgets/CardNumberEntry.vala"
			_tmp1_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("payment-card-visa");
#line 157 "../src/Widgets/CardNumberEntry.vala"
			_tmp2_ = _tmp1_;
#line 157 "../src/Widgets/CardNumberEntry.vala"
			g_object_set ((GtkEntry*) self, "secondary-icon-gicon", (GIcon*) _tmp2_, NULL);
#line 157 "../src/Widgets/CardNumberEntry.vala"
			_g_object_unref0 (_tmp2_);
#line 158 "../src/Widgets/CardNumberEntry.vala"
			break;
#line 492 "CardNumberEntry.c"
		}
#line 155 "../src/Widgets/CardNumberEntry.vala"
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_MASTERCARD:
#line 496 "CardNumberEntry.c"
		{
			GThemedIcon* _tmp3_;
			GThemedIcon* _tmp4_;
#line 160 "../src/Widgets/CardNumberEntry.vala"
			_tmp3_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("payment-card-mastercard");
#line 160 "../src/Widgets/CardNumberEntry.vala"
			_tmp4_ = _tmp3_;
#line 160 "../src/Widgets/CardNumberEntry.vala"
			g_object_set ((GtkEntry*) self, "secondary-icon-gicon", (GIcon*) _tmp4_, NULL);
#line 160 "../src/Widgets/CardNumberEntry.vala"
			_g_object_unref0 (_tmp4_);
#line 161 "../src/Widgets/CardNumberEntry.vala"
			break;
#line 510 "CardNumberEntry.c"
		}
#line 155 "../src/Widgets/CardNumberEntry.vala"
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_AMERICAN_EXPRESS:
#line 514 "CardNumberEntry.c"
		{
			GThemedIcon* _tmp5_;
			GThemedIcon* _tmp6_;
#line 163 "../src/Widgets/CardNumberEntry.vala"
			_tmp5_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("payment-card-amex");
#line 163 "../src/Widgets/CardNumberEntry.vala"
			_tmp6_ = _tmp5_;
#line 163 "../src/Widgets/CardNumberEntry.vala"
			g_object_set ((GtkEntry*) self, "secondary-icon-gicon", (GIcon*) _tmp6_, NULL);
#line 163 "../src/Widgets/CardNumberEntry.vala"
			_g_object_unref0 (_tmp6_);
#line 164 "../src/Widgets/CardNumberEntry.vala"
			break;
#line 528 "CardNumberEntry.c"
		}
#line 155 "../src/Widgets/CardNumberEntry.vala"
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_DISCOVER:
#line 532 "CardNumberEntry.c"
		{
			GThemedIcon* _tmp7_;
			GThemedIcon* _tmp8_;
#line 166 "../src/Widgets/CardNumberEntry.vala"
			_tmp7_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("payment-card-discover");
#line 166 "../src/Widgets/CardNumberEntry.vala"
			_tmp8_ = _tmp7_;
#line 166 "../src/Widgets/CardNumberEntry.vala"
			g_object_set ((GtkEntry*) self, "secondary-icon-gicon", (GIcon*) _tmp8_, NULL);
#line 166 "../src/Widgets/CardNumberEntry.vala"
			_g_object_unref0 (_tmp8_);
#line 167 "../src/Widgets/CardNumberEntry.vala"
			break;
#line 546 "CardNumberEntry.c"
		}
#line 155 "../src/Widgets/CardNumberEntry.vala"
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_DINERS_CLUB:
#line 550 "CardNumberEntry.c"
		{
			GThemedIcon* _tmp9_;
			GThemedIcon* _tmp10_;
#line 169 "../src/Widgets/CardNumberEntry.vala"
			_tmp9_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("payment-card-diners-club");
#line 169 "../src/Widgets/CardNumberEntry.vala"
			_tmp10_ = _tmp9_;
#line 169 "../src/Widgets/CardNumberEntry.vala"
			g_object_set ((GtkEntry*) self, "secondary-icon-gicon", (GIcon*) _tmp10_, NULL);
#line 169 "../src/Widgets/CardNumberEntry.vala"
			_g_object_unref0 (_tmp10_);
#line 170 "../src/Widgets/CardNumberEntry.vala"
			break;
#line 564 "CardNumberEntry.c"
		}
#line 155 "../src/Widgets/CardNumberEntry.vala"
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_JCB:
#line 568 "CardNumberEntry.c"
		{
			GThemedIcon* _tmp11_;
			GThemedIcon* _tmp12_;
#line 172 "../src/Widgets/CardNumberEntry.vala"
			_tmp11_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("payment-card-jcb");
#line 172 "../src/Widgets/CardNumberEntry.vala"
			_tmp12_ = _tmp11_;
#line 172 "../src/Widgets/CardNumberEntry.vala"
			g_object_set ((GtkEntry*) self, "secondary-icon-gicon", (GIcon*) _tmp12_, NULL);
#line 172 "../src/Widgets/CardNumberEntry.vala"
			_g_object_unref0 (_tmp12_);
#line 173 "../src/Widgets/CardNumberEntry.vala"
			break;
#line 582 "CardNumberEntry.c"
		}
#line 155 "../src/Widgets/CardNumberEntry.vala"
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_UNIONPAY:
#line 586 "CardNumberEntry.c"
		{
			GThemedIcon* _tmp13_;
			GThemedIcon* _tmp14_;
#line 175 "../src/Widgets/CardNumberEntry.vala"
			_tmp13_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("payment-card-unionpay");
#line 175 "../src/Widgets/CardNumberEntry.vala"
			_tmp14_ = _tmp13_;
#line 175 "../src/Widgets/CardNumberEntry.vala"
			g_object_set ((GtkEntry*) self, "secondary-icon-gicon", (GIcon*) _tmp14_, NULL);
#line 175 "../src/Widgets/CardNumberEntry.vala"
			_g_object_unref0 (_tmp14_);
#line 176 "../src/Widgets/CardNumberEntry.vala"
			break;
#line 600 "CardNumberEntry.c"
		}
		default:
		{
#line 178 "../src/Widgets/CardNumberEntry.vala"
			g_object_set ((GtkEntry*) self, "secondary-icon-gicon", NULL, NULL);
#line 179 "../src/Widgets/CardNumberEntry.vala"
			break;
#line 608 "CardNumberEntry.c"
		}
	}
}

static gint*
wallet_card_number_entry_get_card_pattern (WalletCardNumberEntry* self,
                                           gint* result_length1)
{
	WalletCardNumberEntryCardType _tmp0_;
	gint* result;
#line 184 "../src/Widgets/CardNumberEntry.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 185 "../src/Widgets/CardNumberEntry.vala"
	_tmp0_ = self->priv->_card_type;
#line 185 "../src/Widgets/CardNumberEntry.vala"
	switch (_tmp0_) {
#line 185 "../src/Widgets/CardNumberEntry.vala"
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_AMERICAN_EXPRESS:
#line 185 "../src/Widgets/CardNumberEntry.vala"
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_DINERS_CLUB:
#line 629 "CardNumberEntry.c"
		{
			gint* _tmp1_;
			gint* _tmp2_;
			gint _tmp2__length1;
#line 188 "../src/Widgets/CardNumberEntry.vala"
			_tmp1_ = g_new0 (gint, 2);
#line 188 "../src/Widgets/CardNumberEntry.vala"
			_tmp1_[0] = 4;
#line 188 "../src/Widgets/CardNumberEntry.vala"
			_tmp1_[1] = 10;
#line 188 "../src/Widgets/CardNumberEntry.vala"
			_tmp2_ = _tmp1_;
#line 188 "../src/Widgets/CardNumberEntry.vala"
			_tmp2__length1 = 2;
#line 188 "../src/Widgets/CardNumberEntry.vala"
			if (result_length1) {
#line 188 "../src/Widgets/CardNumberEntry.vala"
				*result_length1 = _tmp2__length1;
#line 648 "CardNumberEntry.c"
			}
#line 188 "../src/Widgets/CardNumberEntry.vala"
			result = _tmp2_;
#line 188 "../src/Widgets/CardNumberEntry.vala"
			return result;
#line 654 "CardNumberEntry.c"
		}
		default:
#line 185 "../src/Widgets/CardNumberEntry.vala"
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_VISA:
#line 185 "../src/Widgets/CardNumberEntry.vala"
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_MASTERCARD:
#line 185 "../src/Widgets/CardNumberEntry.vala"
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_DISCOVER:
#line 185 "../src/Widgets/CardNumberEntry.vala"
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_JCB:
#line 185 "../src/Widgets/CardNumberEntry.vala"
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_UNIONPAY:
#line 667 "CardNumberEntry.c"
		{
			gint* _tmp3_;
			gint* _tmp4_;
			gint _tmp4__length1;
#line 195 "../src/Widgets/CardNumberEntry.vala"
			_tmp3_ = g_new0 (gint, 3);
#line 195 "../src/Widgets/CardNumberEntry.vala"
			_tmp3_[0] = 4;
#line 195 "../src/Widgets/CardNumberEntry.vala"
			_tmp3_[1] = 8;
#line 195 "../src/Widgets/CardNumberEntry.vala"
			_tmp3_[2] = 12;
#line 195 "../src/Widgets/CardNumberEntry.vala"
			_tmp4_ = _tmp3_;
#line 195 "../src/Widgets/CardNumberEntry.vala"
			_tmp4__length1 = 3;
#line 195 "../src/Widgets/CardNumberEntry.vala"
			if (result_length1) {
#line 195 "../src/Widgets/CardNumberEntry.vala"
				*result_length1 = _tmp4__length1;
#line 688 "CardNumberEntry.c"
			}
#line 195 "../src/Widgets/CardNumberEntry.vala"
			result = _tmp4_;
#line 195 "../src/Widgets/CardNumberEntry.vala"
			return result;
#line 694 "CardNumberEntry.c"
		}
	}
}

static gint
wallet_card_number_entry_get_card_max_length (WalletCardNumberEntry* self)
{
	WalletCardNumberEntryCardType _tmp0_;
	gint result;
#line 199 "../src/Widgets/CardNumberEntry.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 200 "../src/Widgets/CardNumberEntry.vala"
	_tmp0_ = self->priv->_card_type;
#line 200 "../src/Widgets/CardNumberEntry.vala"
	switch (_tmp0_) {
#line 200 "../src/Widgets/CardNumberEntry.vala"
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_AMERICAN_EXPRESS:
#line 712 "CardNumberEntry.c"
		{
#line 202 "../src/Widgets/CardNumberEntry.vala"
			result = 15;
#line 202 "../src/Widgets/CardNumberEntry.vala"
			return result;
#line 718 "CardNumberEntry.c"
		}
#line 200 "../src/Widgets/CardNumberEntry.vala"
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_MASTERCARD:
#line 722 "CardNumberEntry.c"
		{
#line 204 "../src/Widgets/CardNumberEntry.vala"
			result = 16;
#line 204 "../src/Widgets/CardNumberEntry.vala"
			return result;
#line 728 "CardNumberEntry.c"
		}
		default:
#line 200 "../src/Widgets/CardNumberEntry.vala"
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_VISA:
#line 200 "../src/Widgets/CardNumberEntry.vala"
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_DISCOVER:
#line 200 "../src/Widgets/CardNumberEntry.vala"
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_DINERS_CLUB:
#line 200 "../src/Widgets/CardNumberEntry.vala"
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_JCB:
#line 200 "../src/Widgets/CardNumberEntry.vala"
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_UNIONPAY:
#line 741 "CardNumberEntry.c"
		{
#line 211 "../src/Widgets/CardNumberEntry.vala"
			result = 19;
#line 211 "../src/Widgets/CardNumberEntry.vala"
			return result;
#line 747 "CardNumberEntry.c"
		}
	}
}

WalletCardNumberEntry*
wallet_card_number_entry_construct (GType object_type)
{
	WalletCardNumberEntry * self = NULL;
#line 20 "../src/Widgets/CardNumberEntry.vala"
	self = (WalletCardNumberEntry*) g_object_new (object_type, NULL);
#line 20 "../src/Widgets/CardNumberEntry.vala"
	return self;
#line 760 "CardNumberEntry.c"
}

WalletCardNumberEntry*
wallet_card_number_entry_new (void)
{
#line 20 "../src/Widgets/CardNumberEntry.vala"
	return wallet_card_number_entry_construct (WALLET_TYPE_CARD_NUMBER_ENTRY);
#line 768 "CardNumberEntry.c"
}

const gchar*
wallet_card_number_entry_get_card_number (WalletCardNumberEntry* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 21 "../src/Widgets/CardNumberEntry.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 21 "../src/Widgets/CardNumberEntry.vala"
	_tmp0_ = self->priv->_card_number;
#line 21 "../src/Widgets/CardNumberEntry.vala"
	result = _tmp0_;
#line 21 "../src/Widgets/CardNumberEntry.vala"
	return result;
#line 784 "CardNumberEntry.c"
}

void
wallet_card_number_entry_set_card_number (WalletCardNumberEntry* self,
                                          const gchar* value)
{
	gchar* old_value;
#line 21 "../src/Widgets/CardNumberEntry.vala"
	g_return_if_fail (self != NULL);
#line 21 "../src/Widgets/CardNumberEntry.vala"
	old_value = wallet_card_number_entry_get_card_number (self);
#line 21 "../src/Widgets/CardNumberEntry.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 798 "CardNumberEntry.c"
		gchar* _tmp0_;
#line 21 "../src/Widgets/CardNumberEntry.vala"
		_tmp0_ = g_strdup (value);
#line 21 "../src/Widgets/CardNumberEntry.vala"
		_g_free0 (self->priv->_card_number);
#line 21 "../src/Widgets/CardNumberEntry.vala"
		self->priv->_card_number = _tmp0_;
#line 21 "../src/Widgets/CardNumberEntry.vala"
		g_object_notify_by_pspec ((GObject *) self, wallet_card_number_entry_properties[WALLET_CARD_NUMBER_ENTRY_CARD_NUMBER_PROPERTY]);
#line 808 "CardNumberEntry.c"
	}
}

WalletCardNumberEntryCardType
wallet_card_number_entry_get_card_type (WalletCardNumberEntry* self)
{
	WalletCardNumberEntryCardType result;
#line 22 "../src/Widgets/CardNumberEntry.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 22 "../src/Widgets/CardNumberEntry.vala"
	result = self->priv->_card_type;
#line 22 "../src/Widgets/CardNumberEntry.vala"
	return result;
#line 822 "CardNumberEntry.c"
}

static void
wallet_card_number_entry_set_card_type (WalletCardNumberEntry* self,
                                        WalletCardNumberEntryCardType value)
{
	WalletCardNumberEntryCardType old_value;
#line 22 "../src/Widgets/CardNumberEntry.vala"
	g_return_if_fail (self != NULL);
#line 22 "../src/Widgets/CardNumberEntry.vala"
	old_value = wallet_card_number_entry_get_card_type (self);
#line 22 "../src/Widgets/CardNumberEntry.vala"
	if (old_value != value) {
#line 22 "../src/Widgets/CardNumberEntry.vala"
		self->priv->_card_type = value;
#line 22 "../src/Widgets/CardNumberEntry.vala"
		g_object_notify_by_pspec ((GObject *) self, wallet_card_number_entry_properties[WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_PROPERTY]);
#line 840 "CardNumberEntry.c"
	}
}

static void
_wallet_card_number_entry___lambda4_ (WalletCardNumberEntry* self,
                                      gint start_pos,
                                      gint end_pos)
{
#line 65 "../src/Widgets/CardNumberEntry.vala"
	self->priv->insertion = FALSE;
#line 851 "CardNumberEntry.c"
}

static void
__wallet_card_number_entry___lambda4__gtk_editable_delete_text (GtkEditable* _sender,
                                                                gint start_pos,
                                                                gint end_pos,
                                                                gpointer self)
{
#line 64 "../src/Widgets/CardNumberEntry.vala"
	_wallet_card_number_entry___lambda4_ ((WalletCardNumberEntry*) self, start_pos, end_pos);
#line 862 "CardNumberEntry.c"
}

static void
_wallet_card_number_entry___lambda5_ (WalletCardNumberEntry* self,
                                      const gchar* start_pos,
                                      gint end_pos,
                                      gint* pos)
{
#line 68 "../src/Widgets/CardNumberEntry.vala"
	g_return_if_fail (start_pos != NULL);
#line 69 "../src/Widgets/CardNumberEntry.vala"
	self->priv->insertion = TRUE;
#line 875 "CardNumberEntry.c"
}

static void
__wallet_card_number_entry___lambda5__gtk_editable_insert_text (GtkEditable* _sender,
                                                                const gchar* new_text,
                                                                gint new_text_length,
                                                                gint* position,
                                                                gpointer self)
{
#line 68 "../src/Widgets/CardNumberEntry.vala"
	_wallet_card_number_entry___lambda5_ ((WalletCardNumberEntry*) self, new_text, new_text_length, position);
#line 887 "CardNumberEntry.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 72 "../src/Widgets/CardNumberEntry.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 72 "../src/Widgets/CardNumberEntry.vala"
	return _data1_;
#line 897 "CardNumberEntry.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 72 "../src/Widgets/CardNumberEntry.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 907 "CardNumberEntry.c"
		WalletCardNumberEntry* self;
#line 72 "../src/Widgets/CardNumberEntry.vala"
		self = _data1_->self;
#line 72 "../src/Widgets/CardNumberEntry.vala"
		_g_object_unref0 (self);
#line 72 "../src/Widgets/CardNumberEntry.vala"
		g_slice_free (Block1Data, _data1_);
#line 915 "CardNumberEntry.c"
	}
}

static gchar*
string_to_utf8 (const gchar* self,
                gint* result_length1)
{
	gint string_length = 0;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _result_ = NULL;
	gchar* _tmp2_;
	gint _result__length1;
	gint __result__size_;
	gint _tmp3_;
	gchar* _tmp4_;
	gint _tmp4__length1;
	gchar* result;
#line 1570 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1571 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1571 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1571 "glib-2.0.vapi"
	string_length = _tmp1_;
#line 1572 "glib-2.0.vapi"
	_tmp2_ = g_new0 (gchar, string_length + 1);
#line 1572 "glib-2.0.vapi"
	_result_ = _tmp2_;
#line 1572 "glib-2.0.vapi"
	_result__length1 = string_length + 1;
#line 1572 "glib-2.0.vapi"
	__result__size_ = _result__length1;
#line 1573 "glib-2.0.vapi"
	_tmp3_ = _result__length1;
#line 1573 "glib-2.0.vapi"
	_result__length1 = _tmp3_ - 1;
#line 1574 "glib-2.0.vapi"
	memcpy (_result_, self, (gsize) string_length);
#line 1575 "glib-2.0.vapi"
	_tmp4_ = _result_;
#line 1575 "glib-2.0.vapi"
	_tmp4__length1 = _result__length1;
#line 1575 "glib-2.0.vapi"
	if (result_length1) {
#line 1575 "glib-2.0.vapi"
		*result_length1 = _tmp4__length1;
#line 964 "CardNumberEntry.c"
	}
#line 1575 "glib-2.0.vapi"
	result = _tmp4_;
#line 1575 "glib-2.0.vapi"
	return result;
#line 970 "CardNumberEntry.c"
}

static gboolean
_vala_int_array_contains (gint * stack,
                          gssize stack_length,
                          const gint needle)
{
	gssize i;
#line 84 "../src/Widgets/CardNumberEntry.vala"
	for (i = 0; i < stack_length; i++) {
#line 84 "../src/Widgets/CardNumberEntry.vala"
		if (needle == stack[i]) {
#line 84 "../src/Widgets/CardNumberEntry.vala"
			return TRUE;
#line 985 "CardNumberEntry.c"
		}
	}
#line 84 "../src/Widgets/CardNumberEntry.vala"
	return FALSE;
#line 990 "CardNumberEntry.c"
}

static gboolean
___lambda7_ (Block1Data* _data1_)
{
	WalletCardNumberEntry* self;
	gboolean result;
#line 93 "../src/Widgets/CardNumberEntry.vala"
	self = _data1_->self;
#line 94 "../src/Widgets/CardNumberEntry.vala"
	g_signal_emit_by_name ((GtkEntry*) self, "move-cursor", GTK_MOVEMENT_LOGICAL_POSITIONS, _data1_->new_offset - _data1_->end_offset, FALSE);
#line 95 "../src/Widgets/CardNumberEntry.vala"
	result = FALSE;
#line 95 "../src/Widgets/CardNumberEntry.vala"
	return result;
#line 1006 "CardNumberEntry.c"
}

static gboolean
____lambda7__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda7_ (self);
#line 93 "../src/Widgets/CardNumberEntry.vala"
	return result;
#line 1016 "CardNumberEntry.c"
}

static void
_wallet_card_number_entry___lambda6_ (WalletCardNumberEntry* self)
{
	Block1Data* _data1_;
	gint* pattern = NULL;
	gint _tmp0_ = 0;
	gint* _tmp1_;
	gint pattern_length1;
	gint _pattern_size_;
	gchar* number_chars = NULL;
	const gchar* _tmp2_;
	gint _tmp3_ = 0;
	gchar* _tmp4_;
	gint number_chars_length1;
	gint _number_chars_size_;
	GString* builder = NULL;
	GString* _tmp5_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	GString* _tmp21_;
	const gchar* _tmp22_;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	gint _tmp25_;
	gint _tmp26_;
	gint* _tmp27_;
	gint _tmp27__length1;
#line 72 "../src/Widgets/CardNumberEntry.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 72 "../src/Widgets/CardNumberEntry.vala"
	_data1_->_ref_count_ = 1;
#line 72 "../src/Widgets/CardNumberEntry.vala"
	_data1_->self = g_object_ref (self);
#line 73 "../src/Widgets/CardNumberEntry.vala"
	if (self->priv->timeout > ((guint) 0)) {
#line 74 "../src/Widgets/CardNumberEntry.vala"
		g_source_remove (self->priv->timeout);
#line 1058 "CardNumberEntry.c"
	}
#line 76 "../src/Widgets/CardNumberEntry.vala"
	wallet_card_number_entry_update_number (self);
#line 77 "../src/Widgets/CardNumberEntry.vala"
	wallet_card_number_entry_detect_card (self);
#line 78 "../src/Widgets/CardNumberEntry.vala"
	wallet_card_number_entry_change_card_icon (self);
#line 79 "../src/Widgets/CardNumberEntry.vala"
	_tmp1_ = wallet_card_number_entry_get_card_pattern (self, &_tmp0_);
#line 79 "../src/Widgets/CardNumberEntry.vala"
	pattern = _tmp1_;
#line 79 "../src/Widgets/CardNumberEntry.vala"
	pattern_length1 = _tmp0_;
#line 79 "../src/Widgets/CardNumberEntry.vala"
	_pattern_size_ = pattern_length1;
#line 80 "../src/Widgets/CardNumberEntry.vala"
	_tmp2_ = self->priv->_card_number;
#line 80 "../src/Widgets/CardNumberEntry.vala"
	_tmp4_ = string_to_utf8 (_tmp2_, &_tmp3_);
#line 80 "../src/Widgets/CardNumberEntry.vala"
	number_chars = _tmp4_;
#line 80 "../src/Widgets/CardNumberEntry.vala"
	number_chars_length1 = _tmp3_;
#line 80 "../src/Widgets/CardNumberEntry.vala"
	_number_chars_size_ = number_chars_length1;
#line 81 "../src/Widgets/CardNumberEntry.vala"
	_tmp5_ = g_string_new ("");
#line 81 "../src/Widgets/CardNumberEntry.vala"
	builder = _tmp5_;
#line 1088 "CardNumberEntry.c"
	{
		gint i = 0;
#line 82 "../src/Widgets/CardNumberEntry.vala"
		i = 0;
#line 1093 "CardNumberEntry.c"
		{
			gboolean _tmp6_ = FALSE;
#line 82 "../src/Widgets/CardNumberEntry.vala"
			_tmp6_ = TRUE;
#line 82 "../src/Widgets/CardNumberEntry.vala"
			while (TRUE) {
#line 1100 "CardNumberEntry.c"
				gchar* _tmp8_;
				gint _tmp8__length1;
				GString* _tmp9_;
				gchar* _tmp10_;
				gint _tmp10__length1;
				gchar _tmp11_;
				gboolean _tmp12_ = FALSE;
				gboolean _tmp13_ = FALSE;
#line 82 "../src/Widgets/CardNumberEntry.vala"
				if (!_tmp6_) {
#line 1111 "CardNumberEntry.c"
					gint _tmp7_;
#line 82 "../src/Widgets/CardNumberEntry.vala"
					_tmp7_ = i;
#line 82 "../src/Widgets/CardNumberEntry.vala"
					i = _tmp7_ + 1;
#line 1117 "CardNumberEntry.c"
				}
#line 82 "../src/Widgets/CardNumberEntry.vala"
				_tmp6_ = FALSE;
#line 82 "../src/Widgets/CardNumberEntry.vala"
				_tmp8_ = number_chars;
#line 82 "../src/Widgets/CardNumberEntry.vala"
				_tmp8__length1 = number_chars_length1;
#line 82 "../src/Widgets/CardNumberEntry.vala"
				if (!(i < _tmp8__length1)) {
#line 82 "../src/Widgets/CardNumberEntry.vala"
					break;
#line 1129 "CardNumberEntry.c"
				}
#line 83 "../src/Widgets/CardNumberEntry.vala"
				_tmp9_ = builder;
#line 83 "../src/Widgets/CardNumberEntry.vala"
				_tmp10_ = number_chars;
#line 83 "../src/Widgets/CardNumberEntry.vala"
				_tmp10__length1 = number_chars_length1;
#line 83 "../src/Widgets/CardNumberEntry.vala"
				_tmp11_ = _tmp10_[i];
#line 83 "../src/Widgets/CardNumberEntry.vala"
				g_string_append_c (_tmp9_, _tmp11_);
#line 84 "../src/Widgets/CardNumberEntry.vala"
				if (self->priv->insertion) {
#line 84 "../src/Widgets/CardNumberEntry.vala"
					_tmp13_ = TRUE;
#line 1145 "CardNumberEntry.c"
				} else {
					gchar* _tmp14_;
					gint _tmp14__length1;
#line 84 "../src/Widgets/CardNumberEntry.vala"
					_tmp14_ = number_chars;
#line 84 "../src/Widgets/CardNumberEntry.vala"
					_tmp14__length1 = number_chars_length1;
#line 84 "../src/Widgets/CardNumberEntry.vala"
					_tmp13_ = (i + 1) != _tmp14__length1;
#line 1155 "CardNumberEntry.c"
				}
#line 84 "../src/Widgets/CardNumberEntry.vala"
				if (_tmp13_) {
#line 1159 "CardNumberEntry.c"
					gint* _tmp15_;
					gint _tmp15__length1;
#line 84 "../src/Widgets/CardNumberEntry.vala"
					_tmp15_ = pattern;
#line 84 "../src/Widgets/CardNumberEntry.vala"
					_tmp15__length1 = pattern_length1;
#line 84 "../src/Widgets/CardNumberEntry.vala"
					_tmp12_ = _vala_int_array_contains (_tmp15_, _tmp15__length1, i + 1);
#line 1168 "CardNumberEntry.c"
				} else {
#line 84 "../src/Widgets/CardNumberEntry.vala"
					_tmp12_ = FALSE;
#line 1172 "CardNumberEntry.c"
				}
#line 84 "../src/Widgets/CardNumberEntry.vala"
				if (_tmp12_) {
#line 1176 "CardNumberEntry.c"
					GString* _tmp16_;
#line 85 "../src/Widgets/CardNumberEntry.vala"
					_tmp16_ = builder;
#line 85 "../src/Widgets/CardNumberEntry.vala"
					g_string_append_c (_tmp16_, ' ');
#line 1182 "CardNumberEntry.c"
				}
			}
		}
	}
#line 89 "../src/Widgets/CardNumberEntry.vala"
	_tmp17_ = gtk_entry_get_text ((GtkEntry*) self);
#line 89 "../src/Widgets/CardNumberEntry.vala"
	_tmp18_ = _tmp17_;
#line 89 "../src/Widgets/CardNumberEntry.vala"
	g_object_get ((GtkEntry*) self, "cursor-position", &_tmp19_, NULL);
#line 89 "../src/Widgets/CardNumberEntry.vala"
	_tmp20_ = _tmp19_;
#line 89 "../src/Widgets/CardNumberEntry.vala"
	_data1_->end_offset = (g_utf8_strlen (_tmp18_, (gssize) -1) - 1) - _tmp20_;
#line 90 "../src/Widgets/CardNumberEntry.vala"
	_tmp21_ = builder;
#line 90 "../src/Widgets/CardNumberEntry.vala"
	_tmp22_ = _tmp21_->str;
#line 90 "../src/Widgets/CardNumberEntry.vala"
	gtk_entry_set_text ((GtkEntry*) self, _tmp22_);
#line 91 "../src/Widgets/CardNumberEntry.vala"
	_tmp23_ = gtk_entry_get_text ((GtkEntry*) self);
#line 91 "../src/Widgets/CardNumberEntry.vala"
	_tmp24_ = _tmp23_;
#line 91 "../src/Widgets/CardNumberEntry.vala"
	g_object_get ((GtkEntry*) self, "cursor-position", &_tmp25_, NULL);
#line 91 "../src/Widgets/CardNumberEntry.vala"
	_tmp26_ = _tmp25_;
#line 91 "../src/Widgets/CardNumberEntry.vala"
	_data1_->new_offset = (g_utf8_strlen (_tmp24_, (gssize) -1) - 1) - _tmp26_;
#line 92 "../src/Widgets/CardNumberEntry.vala"
	if (_data1_->end_offset != _data1_->new_offset) {
#line 93 "../src/Widgets/CardNumberEntry.vala"
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda7__gsource_func, block1_data_ref (_data1_), block1_data_unref);
#line 1217 "CardNumberEntry.c"
	}
#line 99 "../src/Widgets/CardNumberEntry.vala"
	_tmp27_ = pattern;
#line 99 "../src/Widgets/CardNumberEntry.vala"
	_tmp27__length1 = pattern_length1;
#line 99 "../src/Widgets/CardNumberEntry.vala"
	gtk_entry_set_max_length ((GtkEntry*) self, wallet_card_number_entry_get_card_max_length (self) + _tmp27__length1);
#line 72 "../src/Widgets/CardNumberEntry.vala"
	_g_string_free0 (builder);
#line 72 "../src/Widgets/CardNumberEntry.vala"
	number_chars = (g_free (number_chars), NULL);
#line 72 "../src/Widgets/CardNumberEntry.vala"
	pattern = (g_free (pattern), NULL);
#line 72 "../src/Widgets/CardNumberEntry.vala"
	block1_data_unref (_data1_);
#line 72 "../src/Widgets/CardNumberEntry.vala"
	_data1_ = NULL;
#line 1235 "CardNumberEntry.c"
}

static void
__wallet_card_number_entry___lambda6__gtk_editable_changed (GtkEditable* _sender,
                                                            gpointer self)
{
#line 72 "../src/Widgets/CardNumberEntry.vala"
	_wallet_card_number_entry___lambda6_ ((WalletCardNumberEntry*) self);
#line 1244 "CardNumberEntry.c"
}

static GObject *
wallet_card_number_entry_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WalletCardNumberEntry * self;
	GThemedIcon* _tmp0_;
	GThemedIcon* _tmp1_;
#line 59 "../src/Widgets/CardNumberEntry.vala"
	parent_class = G_OBJECT_CLASS (wallet_card_number_entry_parent_class);
#line 59 "../src/Widgets/CardNumberEntry.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 59 "../src/Widgets/CardNumberEntry.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WALLET_TYPE_CARD_NUMBER_ENTRY, WalletCardNumberEntry);
#line 60 "../src/Widgets/CardNumberEntry.vala"
	gtk_entry_set_input_purpose ((GtkEntry*) self, GTK_INPUT_PURPOSE_DIGITS);
#line 61 "../src/Widgets/CardNumberEntry.vala"
	gtk_entry_set_max_length ((GtkEntry*) self, 26);
#line 62 "../src/Widgets/CardNumberEntry.vala"
	gtk_entry_set_placeholder_text ((GtkEntry*) self, _ ("Card Number"));
#line 63 "../src/Widgets/CardNumberEntry.vala"
	_tmp0_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("payment-card-symbolic");
#line 63 "../src/Widgets/CardNumberEntry.vala"
	_tmp1_ = _tmp0_;
#line 63 "../src/Widgets/CardNumberEntry.vala"
	g_object_set ((GtkEntry*) self, "primary-icon-gicon", (GIcon*) _tmp1_, NULL);
#line 63 "../src/Widgets/CardNumberEntry.vala"
	_g_object_unref0 (_tmp1_);
#line 64 "../src/Widgets/CardNumberEntry.vala"
	g_signal_connect_object ((GtkEditable*) self, "delete-text", (GCallback) __wallet_card_number_entry___lambda4__gtk_editable_delete_text, self, 0);
#line 68 "../src/Widgets/CardNumberEntry.vala"
	g_signal_connect_object ((GtkEditable*) self, "insert-text", (GCallback) __wallet_card_number_entry___lambda5__gtk_editable_insert_text, self, 0);
#line 72 "../src/Widgets/CardNumberEntry.vala"
	g_signal_connect_object ((GtkEditable*) self, "changed", (GCallback) __wallet_card_number_entry___lambda6__gtk_editable_changed, self, 0);
#line 59 "../src/Widgets/CardNumberEntry.vala"
	return obj;
#line 1285 "CardNumberEntry.c"
}

static void
wallet_card_number_entry_class_init (WalletCardNumberEntryClass * klass,
                                     gpointer klass_data)
{
#line 20 "../src/Widgets/CardNumberEntry.vala"
	wallet_card_number_entry_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/Widgets/CardNumberEntry.vala"
	g_type_class_adjust_private_offset (klass, &WalletCardNumberEntry_private_offset);
#line 20 "../src/Widgets/CardNumberEntry.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_wallet_card_number_entry_get_property;
#line 20 "../src/Widgets/CardNumberEntry.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_wallet_card_number_entry_set_property;
#line 20 "../src/Widgets/CardNumberEntry.vala"
	G_OBJECT_CLASS (klass)->constructor = wallet_card_number_entry_constructor;
#line 20 "../src/Widgets/CardNumberEntry.vala"
	G_OBJECT_CLASS (klass)->finalize = wallet_card_number_entry_finalize;
#line 20 "../src/Widgets/CardNumberEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WALLET_CARD_NUMBER_ENTRY_CARD_NUMBER_PROPERTY, wallet_card_number_entry_properties[WALLET_CARD_NUMBER_ENTRY_CARD_NUMBER_PROPERTY] = g_param_spec_string ("card-number", "card-number", "card-number", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 20 "../src/Widgets/CardNumberEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_PROPERTY, wallet_card_number_entry_properties[WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_PROPERTY] = g_param_spec_enum ("card-type", "card-type", "card-type", WALLET_CARD_NUMBER_ENTRY_TYPE_CARD_TYPE, WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_UNKNOWN, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1308 "CardNumberEntry.c"
}

static void
wallet_card_number_entry_instance_init (WalletCardNumberEntry * self,
                                        gpointer klass)
{
#line 20 "../src/Widgets/CardNumberEntry.vala"
	self->priv = wallet_card_number_entry_get_instance_private (self);
#line 22 "../src/Widgets/CardNumberEntry.vala"
	self->priv->_card_type = WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_UNKNOWN;
#line 56 "../src/Widgets/CardNumberEntry.vala"
	self->priv->timeout = (guint) 0;
#line 57 "../src/Widgets/CardNumberEntry.vala"
	self->priv->insertion = TRUE;
#line 1323 "CardNumberEntry.c"
}

static void
wallet_card_number_entry_finalize (GObject * obj)
{
	WalletCardNumberEntry * self;
#line 20 "../src/Widgets/CardNumberEntry.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WALLET_TYPE_CARD_NUMBER_ENTRY, WalletCardNumberEntry);
#line 21 "../src/Widgets/CardNumberEntry.vala"
	_g_free0 (self->priv->_card_number);
#line 20 "../src/Widgets/CardNumberEntry.vala"
	G_OBJECT_CLASS (wallet_card_number_entry_parent_class)->finalize (obj);
#line 1336 "CardNumberEntry.c"
}

static GType
wallet_card_number_entry_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WalletCardNumberEntryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) wallet_card_number_entry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WalletCardNumberEntry), 0, (GInstanceInitFunc) wallet_card_number_entry_instance_init, NULL };
	GType wallet_card_number_entry_type_id;
	wallet_card_number_entry_type_id = g_type_register_static (gtk_entry_get_type (), "WalletCardNumberEntry", &g_define_type_info, 0);
	WalletCardNumberEntry_private_offset = g_type_add_instance_private (wallet_card_number_entry_type_id, sizeof (WalletCardNumberEntryPrivate));
	return wallet_card_number_entry_type_id;
}

GType
wallet_card_number_entry_get_type (void)
{
	static volatile gsize wallet_card_number_entry_type_id__once = 0;
	if (g_once_init_enter (&wallet_card_number_entry_type_id__once)) {
		GType wallet_card_number_entry_type_id;
		wallet_card_number_entry_type_id = wallet_card_number_entry_get_type_once ();
		g_once_init_leave (&wallet_card_number_entry_type_id__once, wallet_card_number_entry_type_id);
	}
	return wallet_card_number_entry_type_id__once;
}

static void
_vala_wallet_card_number_entry_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	WalletCardNumberEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WALLET_TYPE_CARD_NUMBER_ENTRY, WalletCardNumberEntry);
#line 20 "../src/Widgets/CardNumberEntry.vala"
	switch (property_id) {
#line 20 "../src/Widgets/CardNumberEntry.vala"
		case WALLET_CARD_NUMBER_ENTRY_CARD_NUMBER_PROPERTY:
#line 20 "../src/Widgets/CardNumberEntry.vala"
		g_value_set_string (value, wallet_card_number_entry_get_card_number (self));
#line 20 "../src/Widgets/CardNumberEntry.vala"
		break;
#line 20 "../src/Widgets/CardNumberEntry.vala"
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_PROPERTY:
#line 20 "../src/Widgets/CardNumberEntry.vala"
		g_value_set_enum (value, wallet_card_number_entry_get_card_type (self));
#line 20 "../src/Widgets/CardNumberEntry.vala"
		break;
#line 1383 "CardNumberEntry.c"
		default:
#line 20 "../src/Widgets/CardNumberEntry.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/Widgets/CardNumberEntry.vala"
		break;
#line 1389 "CardNumberEntry.c"
	}
}

static void
_vala_wallet_card_number_entry_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	WalletCardNumberEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WALLET_TYPE_CARD_NUMBER_ENTRY, WalletCardNumberEntry);
#line 20 "../src/Widgets/CardNumberEntry.vala"
	switch (property_id) {
#line 20 "../src/Widgets/CardNumberEntry.vala"
		case WALLET_CARD_NUMBER_ENTRY_CARD_NUMBER_PROPERTY:
#line 20 "../src/Widgets/CardNumberEntry.vala"
		wallet_card_number_entry_set_card_number (self, g_value_get_string (value));
#line 20 "../src/Widgets/CardNumberEntry.vala"
		break;
#line 20 "../src/Widgets/CardNumberEntry.vala"
		case WALLET_CARD_NUMBER_ENTRY_CARD_TYPE_PROPERTY:
#line 20 "../src/Widgets/CardNumberEntry.vala"
		wallet_card_number_entry_set_card_type (self, g_value_get_enum (value));
#line 20 "../src/Widgets/CardNumberEntry.vala"
		break;
#line 1415 "CardNumberEntry.c"
		default:
#line 20 "../src/Widgets/CardNumberEntry.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/Widgets/CardNumberEntry.vala"
		break;
#line 1421 "CardNumberEntry.c"
	}
}

