/* SecretItemRow.c generated by valac 0.56.12, the Vala compiler
 * generated from SecretItemRow.vala, do not modify */

/*
 * Copyright 2020 elementary, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "io.elementary.switchboard.wallet.h"
#include <gtk/gtk.h>
#include <libsecret/secret.h>
#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>

enum  {
	WALLET_SECRET_ITEM_ROW_0_PROPERTY,
	WALLET_SECRET_ITEM_ROW_CLOSE_REVEALER_PROPERTY,
	WALLET_SECRET_ITEM_ROW_SECRET_ITEM_PROPERTY,
	WALLET_SECRET_ITEM_ROW_NUM_PROPERTIES
};
static GParamSpec* wallet_secret_item_row_properties[WALLET_SECRET_ITEM_ROW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _WalletSecretItemRowDeleteSecretData WalletSecretItemRowDeleteSecretData;
typedef struct _Block2Data Block2Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))

struct _WalletSecretItemRowPrivate {
	GtkRevealer* _close_revealer;
	SecretItem* _secret_item;
};

struct _WalletSecretItemRowDeleteSecretData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	WalletSecretItemRow* self;
	SecretItem* _tmp0_;
	GError* _error_;
	GError* _tmp1_;
	const gchar* _tmp2_;
	GError* _inner_error0_;
};

struct _Block2Data {
	int _ref_count_;
	WalletSecretItemRow* self;
	GtkRevealer* revealer;
};

static gint WalletSecretItemRow_private_offset;
static gpointer wallet_secret_item_row_parent_class = NULL;
static GtkCssProvider* wallet_secret_item_row_css_provider;
static GtkCssProvider* wallet_secret_item_row_css_provider = NULL;

static void wallet_secret_item_row_delete_secret_data_free (gpointer _data);
static void wallet_secret_item_row_delete_secret (WalletSecretItemRow* self,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
static void wallet_secret_item_row_delete_secret_finish (WalletSecretItemRow* self,
                                                  GAsyncResult* _res_);
static gboolean wallet_secret_item_row_delete_secret_co (WalletSecretItemRowDeleteSecretData* _data_);
static void wallet_secret_item_row_delete_secret_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_);
static void wallet_secret_item_row_set_close_revealer (WalletSecretItemRow* self,
                                                GtkRevealer* value);
static GObject * wallet_secret_item_row_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static gboolean _wallet_secret_item_row___lambda13_ (Block2Data* _data2_);
static gboolean __lambda14_ (WalletSecretItemRow* self);
static gboolean ___lambda14__gsource_func (gpointer self);
static gboolean __wallet_secret_item_row___lambda13__gtk_widget_button_release_event (GtkWidget* _sender,
                                                                               GdkEventButton* event,
                                                                               gpointer self);
static gboolean _wallet_secret_item_row___lambda15_ (WalletSecretItemRow* self);
static gboolean __wallet_secret_item_row___lambda15__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                          GdkEventFocus* event,
                                                                          gpointer self);
static void wallet_secret_item_row_finalize (GObject * obj);
static GType wallet_secret_item_row_get_type_once (void);
static void _vala_wallet_secret_item_row_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_wallet_secret_item_row_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);

static inline gpointer
wallet_secret_item_row_get_instance_private (WalletSecretItemRow* self)
{
	return G_STRUCT_MEMBER_P (self, WalletSecretItemRow_private_offset);
}

WalletSecretItemRow*
wallet_secret_item_row_construct (GType object_type,
                                  SecretItem* secret_item)
{
	WalletSecretItemRow * self = NULL;
#line 24 "../src/Widgets/SecretItemRow.vala"
	g_return_val_if_fail (secret_item != NULL, NULL);
#line 25 "../src/Widgets/SecretItemRow.vala"
	self = (WalletSecretItemRow*) g_object_new (object_type, "secret-item", secret_item, NULL);
#line 24 "../src/Widgets/SecretItemRow.vala"
	return self;
#line 133 "SecretItemRow.c"
}

WalletSecretItemRow*
wallet_secret_item_row_new (SecretItem* secret_item)
{
#line 24 "../src/Widgets/SecretItemRow.vala"
	return wallet_secret_item_row_construct (WALLET_TYPE_SECRET_ITEM_ROW, secret_item);
#line 141 "SecretItemRow.c"
}

static void
wallet_secret_item_row_delete_secret_data_free (gpointer _data)
{
	WalletSecretItemRowDeleteSecretData* _data_;
	_data_ = _data;
#line 18 "../src/Widgets/SecretItemRow.vala"
	_g_object_unref0 (_data_->self);
#line 18 "../src/Widgets/SecretItemRow.vala"
	g_slice_free (WalletSecretItemRowDeleteSecretData, _data_);
#line 153 "SecretItemRow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 18 "../src/Widgets/SecretItemRow.vala"
	return self ? g_object_ref (self) : NULL;
#line 161 "SecretItemRow.c"
}

static void
wallet_secret_item_row_delete_secret (WalletSecretItemRow* self,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_)
{
	WalletSecretItemRowDeleteSecretData* _data_;
	WalletSecretItemRow* _tmp0_;
#line 18 "../src/Widgets/SecretItemRow.vala"
	g_return_if_fail (self != NULL);
#line 18 "../src/Widgets/SecretItemRow.vala"
	_data_ = g_slice_new0 (WalletSecretItemRowDeleteSecretData);
#line 18 "../src/Widgets/SecretItemRow.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 18 "../src/Widgets/SecretItemRow.vala"
	g_task_set_task_data (_data_->_async_result, _data_, wallet_secret_item_row_delete_secret_data_free);
#line 18 "../src/Widgets/SecretItemRow.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 18 "../src/Widgets/SecretItemRow.vala"
	_data_->self = _tmp0_;
#line 18 "../src/Widgets/SecretItemRow.vala"
	wallet_secret_item_row_delete_secret_co (_data_);
#line 185 "SecretItemRow.c"
}

static void
wallet_secret_item_row_delete_secret_finish (WalletSecretItemRow* self,
                                             GAsyncResult* _res_)
{
	WalletSecretItemRowDeleteSecretData* _data_;
#line 18 "../src/Widgets/SecretItemRow.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 195 "SecretItemRow.c"
}

static void
wallet_secret_item_row_delete_secret_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_)
{
	WalletSecretItemRowDeleteSecretData* _data_;
#line 109 "../src/Widgets/SecretItemRow.vala"
	_data_ = _user_data_;
#line 109 "../src/Widgets/SecretItemRow.vala"
	_data_->_source_object_ = source_object;
#line 109 "../src/Widgets/SecretItemRow.vala"
	_data_->_res_ = _res_;
#line 109 "../src/Widgets/SecretItemRow.vala"
	wallet_secret_item_row_delete_secret_co (_data_);
#line 212 "SecretItemRow.c"
}

static gboolean
wallet_secret_item_row_delete_secret_co (WalletSecretItemRowDeleteSecretData* _data_)
{
#line 107 "../src/Widgets/SecretItemRow.vala"
	switch (_data_->_state_) {
#line 107 "../src/Widgets/SecretItemRow.vala"
		case 0:
#line 222 "SecretItemRow.c"
		goto _state_0;
#line 107 "../src/Widgets/SecretItemRow.vala"
		case 1:
#line 226 "SecretItemRow.c"
		goto _state_1;
		default:
#line 107 "../src/Widgets/SecretItemRow.vala"
		g_assert_not_reached ();
#line 231 "SecretItemRow.c"
	}
	_state_0:
	{
#line 109 "../src/Widgets/SecretItemRow.vala"
		_data_->_tmp0_ = _data_->self->priv->_secret_item;
#line 109 "../src/Widgets/SecretItemRow.vala"
		_data_->_state_ = 1;
#line 109 "../src/Widgets/SecretItemRow.vala"
		secret_item_delete (_data_->_tmp0_, NULL, wallet_secret_item_row_delete_secret_ready, _data_);
#line 109 "../src/Widgets/SecretItemRow.vala"
		return FALSE;
#line 243 "SecretItemRow.c"
		_state_1:
#line 109 "../src/Widgets/SecretItemRow.vala"
		secret_item_delete_finish (_data_->_tmp0_, _data_->_res_, &_data_->_inner_error0_);
#line 109 "../src/Widgets/SecretItemRow.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 249 "SecretItemRow.c"
			goto __catch0_g_error;
		}
#line 110 "../src/Widgets/SecretItemRow.vala"
		gtk_widget_destroy ((GtkWidget*) _data_->self);
#line 254 "SecretItemRow.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 108 "../src/Widgets/SecretItemRow.vala"
		_data_->_error_ = _data_->_inner_error0_;
#line 108 "../src/Widgets/SecretItemRow.vala"
		_data_->_inner_error0_ = NULL;
#line 112 "../src/Widgets/SecretItemRow.vala"
		_data_->_tmp1_ = _data_->_error_;
#line 112 "../src/Widgets/SecretItemRow.vala"
		_data_->_tmp2_ = _data_->_tmp1_->message;
#line 112 "../src/Widgets/SecretItemRow.vala"
		g_critical ("SecretItemRow.vala:112: %s", _data_->_tmp2_);
#line 108 "../src/Widgets/SecretItemRow.vala"
		_g_error_free0 (_data_->_error_);
#line 271 "SecretItemRow.c"
	}
	__finally0:
#line 108 "../src/Widgets/SecretItemRow.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 108 "../src/Widgets/SecretItemRow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 108 "../src/Widgets/SecretItemRow.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 108 "../src/Widgets/SecretItemRow.vala"
		g_object_unref (_data_->_async_result);
#line 108 "../src/Widgets/SecretItemRow.vala"
		return FALSE;
#line 284 "SecretItemRow.c"
	}
#line 107 "../src/Widgets/SecretItemRow.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 107 "../src/Widgets/SecretItemRow.vala"
	if (_data_->_state_ != 0) {
#line 107 "../src/Widgets/SecretItemRow.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 107 "../src/Widgets/SecretItemRow.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 294 "SecretItemRow.c"
		}
	}
#line 107 "../src/Widgets/SecretItemRow.vala"
	g_object_unref (_data_->_async_result);
#line 107 "../src/Widgets/SecretItemRow.vala"
	return FALSE;
#line 301 "SecretItemRow.c"
}

GtkRevealer*
wallet_secret_item_row_get_close_revealer (WalletSecretItemRow* self)
{
	GtkRevealer* result;
	GtkRevealer* _tmp0_;
#line 19 "../src/Widgets/SecretItemRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 19 "../src/Widgets/SecretItemRow.vala"
	_tmp0_ = self->priv->_close_revealer;
#line 19 "../src/Widgets/SecretItemRow.vala"
	result = _tmp0_;
#line 19 "../src/Widgets/SecretItemRow.vala"
	return result;
#line 317 "SecretItemRow.c"
}

static void
wallet_secret_item_row_set_close_revealer (WalletSecretItemRow* self,
                                           GtkRevealer* value)
{
	GtkRevealer* old_value;
#line 19 "../src/Widgets/SecretItemRow.vala"
	g_return_if_fail (self != NULL);
#line 19 "../src/Widgets/SecretItemRow.vala"
	old_value = wallet_secret_item_row_get_close_revealer (self);
#line 19 "../src/Widgets/SecretItemRow.vala"
	if (old_value != value) {
#line 331 "SecretItemRow.c"
		GtkRevealer* _tmp0_;
#line 19 "../src/Widgets/SecretItemRow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 19 "../src/Widgets/SecretItemRow.vala"
		_g_object_unref0 (self->priv->_close_revealer);
#line 19 "../src/Widgets/SecretItemRow.vala"
		self->priv->_close_revealer = _tmp0_;
#line 19 "../src/Widgets/SecretItemRow.vala"
		g_object_notify_by_pspec ((GObject *) self, wallet_secret_item_row_properties[WALLET_SECRET_ITEM_ROW_CLOSE_REVEALER_PROPERTY]);
#line 341 "SecretItemRow.c"
	}
}

SecretItem*
wallet_secret_item_row_get_secret_item (WalletSecretItemRow* self)
{
	SecretItem* result;
	SecretItem* _tmp0_;
#line 20 "../src/Widgets/SecretItemRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 20 "../src/Widgets/SecretItemRow.vala"
	_tmp0_ = self->priv->_secret_item;
#line 20 "../src/Widgets/SecretItemRow.vala"
	result = _tmp0_;
#line 20 "../src/Widgets/SecretItemRow.vala"
	return result;
#line 358 "SecretItemRow.c"
}

static void
wallet_secret_item_row_set_secret_item (WalletSecretItemRow* self,
                                        SecretItem* value)
{
	SecretItem* old_value;
#line 20 "../src/Widgets/SecretItemRow.vala"
	g_return_if_fail (self != NULL);
#line 20 "../src/Widgets/SecretItemRow.vala"
	old_value = wallet_secret_item_row_get_secret_item (self);
#line 20 "../src/Widgets/SecretItemRow.vala"
	if (old_value != value) {
#line 372 "SecretItemRow.c"
		SecretItem* _tmp0_;
#line 20 "../src/Widgets/SecretItemRow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 20 "../src/Widgets/SecretItemRow.vala"
		_g_object_unref0 (self->priv->_secret_item);
#line 20 "../src/Widgets/SecretItemRow.vala"
		self->priv->_secret_item = _tmp0_;
#line 20 "../src/Widgets/SecretItemRow.vala"
		g_object_notify_by_pspec ((GObject *) self, wallet_secret_item_row_properties[WALLET_SECRET_ITEM_ROW_SECRET_ITEM_PROPERTY]);
#line 382 "SecretItemRow.c"
	}
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 33 "../src/Widgets/SecretItemRow.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 33 "../src/Widgets/SecretItemRow.vala"
	return _data2_;
#line 393 "SecretItemRow.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 33 "../src/Widgets/SecretItemRow.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 403 "SecretItemRow.c"
		WalletSecretItemRow* self;
#line 33 "../src/Widgets/SecretItemRow.vala"
		self = _data2_->self;
#line 33 "../src/Widgets/SecretItemRow.vala"
		_g_object_unref0 (_data2_->revealer);
#line 33 "../src/Widgets/SecretItemRow.vala"
		_g_object_unref0 (self);
#line 33 "../src/Widgets/SecretItemRow.vala"
		g_slice_free (Block2Data, _data2_);
#line 413 "SecretItemRow.c"
	}
}

static gboolean
__lambda14_ (WalletSecretItemRow* self)
{
	gboolean result;
#line 97 "../src/Widgets/SecretItemRow.vala"
	wallet_secret_item_row_delete_secret (self, NULL, NULL);
#line 98 "../src/Widgets/SecretItemRow.vala"
	result = GDK_EVENT_STOP;
#line 98 "../src/Widgets/SecretItemRow.vala"
	return result;
#line 427 "SecretItemRow.c"
}

static gboolean
___lambda14__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda14_ ((WalletSecretItemRow*) self);
#line 96 "../src/Widgets/SecretItemRow.vala"
	return result;
#line 437 "SecretItemRow.c"
}

static gboolean
_wallet_secret_item_row___lambda13_ (Block2Data* _data2_)
{
	WalletSecretItemRow* self;
	GtkRevealer* _tmp0_;
	GtkRevealer* _tmp1_;
	GtkRevealer* _tmp2_;
	guint _tmp3_;
	guint _tmp4_;
#line 92 "../src/Widgets/SecretItemRow.vala"
	self = _data2_->self;
#line 93 "../src/Widgets/SecretItemRow.vala"
	_tmp0_ = _data2_->revealer;
#line 93 "../src/Widgets/SecretItemRow.vala"
	gtk_revealer_set_transition_duration (_tmp0_, (guint) 195);
#line 94 "../src/Widgets/SecretItemRow.vala"
	_tmp1_ = _data2_->revealer;
#line 94 "../src/Widgets/SecretItemRow.vala"
	gtk_revealer_set_reveal_child (_tmp1_, FALSE);
#line 96 "../src/Widgets/SecretItemRow.vala"
	_tmp2_ = _data2_->revealer;
#line 96 "../src/Widgets/SecretItemRow.vala"
	_tmp3_ = gtk_revealer_get_transition_duration (_tmp2_);
#line 96 "../src/Widgets/SecretItemRow.vala"
	_tmp4_ = _tmp3_;
#line 96 "../src/Widgets/SecretItemRow.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, _tmp4_, ___lambda14__gsource_func, g_object_ref (self), g_object_unref);
#line 467 "SecretItemRow.c"
}

static gboolean
__wallet_secret_item_row___lambda13__gtk_widget_button_release_event (GtkWidget* _sender,
                                                                      GdkEventButton* event,
                                                                      gpointer self)
{
	gboolean result;
	result = _wallet_secret_item_row___lambda13_ (self);
#line 92 "../src/Widgets/SecretItemRow.vala"
	return result;
#line 479 "SecretItemRow.c"
}

static gboolean
_wallet_secret_item_row___lambda15_ (WalletSecretItemRow* self)
{
	GtkRevealer* _tmp0_;
#line 103 "../src/Widgets/SecretItemRow.vala"
	_tmp0_ = self->priv->_close_revealer;
#line 103 "../src/Widgets/SecretItemRow.vala"
	gtk_revealer_set_reveal_child (_tmp0_, FALSE);
#line 490 "SecretItemRow.c"
}

static gboolean
__wallet_secret_item_row___lambda15__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                 GdkEventFocus* event,
                                                                 gpointer self)
{
	gboolean result;
	result = _wallet_secret_item_row___lambda15_ ((WalletSecretItemRow*) self);
#line 102 "../src/Widgets/SecretItemRow.vala"
	return result;
#line 502 "SecretItemRow.c"
}

static GObject *
wallet_secret_item_row_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WalletSecretItemRow * self;
	Block2Data* _data2_;
	GtkImage* delete_image = NULL;
	GtkImage* _tmp0_;
	GtkImage* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkCssProvider* _tmp3_;
	GtkButton* delete_button = NULL;
	GtkButton* _tmp4_;
	GtkButton* _tmp5_;
	GtkImage* _tmp6_;
	GtkButton* _tmp7_;
	GtkButton* _tmp8_;
	GtkButton* _tmp9_;
	GtkStyleContext* delete_button_context = NULL;
	GtkButton* _tmp10_;
	GtkStyleContext* _tmp11_;
	GtkStyleContext* _tmp12_;
	GtkStyleContext* _tmp13_;
	GtkCssProvider* _tmp14_;
	GtkRevealer* _tmp15_;
	GtkRevealer* _tmp16_;
	GtkRevealer* _tmp17_;
	GtkRevealer* _tmp18_;
	GtkButton* _tmp19_;
	GtkImage* image = NULL;
	GtkImage* _tmp20_;
	GtkImage* _tmp21_;
	GtkLabel* title_label = NULL;
	SecretItem* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	GtkLabel* _tmp25_;
	GtkLabel* _tmp26_;
	GtkLabel* _tmp27_;
	GtkLabel* _tmp28_;
	GtkLabel* description = NULL;
	GtkLabel* _tmp29_;
	GtkLabel* _tmp30_;
	GtkLabel* _tmp31_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp32_;
	GtkGrid* _tmp33_;
	GtkGrid* _tmp34_;
	GtkGrid* _tmp35_;
	GtkGrid* _tmp36_;
	GtkRevealer* _tmp37_;
	GtkGrid* _tmp38_;
	GtkImage* _tmp39_;
	GtkGrid* _tmp40_;
	GtkLabel* _tmp41_;
	GtkGrid* _tmp42_;
	GtkLabel* _tmp43_;
	GtkRevealer* _tmp44_;
	GtkRevealer* _tmp45_;
	GtkRevealer* _tmp46_;
	GtkRevealer* _tmp47_;
	GtkGrid* _tmp48_;
	GtkRevealer* _tmp49_;
	GHashTable* attributes = NULL;
	SecretItem* _tmp50_;
	GHashTable* _tmp51_;
	gchar* exp = NULL;
	GHashTable* _tmp52_;
	gconstpointer _tmp53_;
	gchar* _tmp54_;
	const gchar* _tmp55_;
	gchar* brand = NULL;
	GHashTable* _tmp68_;
	gconstpointer _tmp69_;
	gchar* _tmp70_;
	const gchar* _tmp71_;
	GtkButton* _tmp78_;
#line 33 "../src/Widgets/SecretItemRow.vala"
	parent_class = G_OBJECT_CLASS (wallet_secret_item_row_parent_class);
#line 33 "../src/Widgets/SecretItemRow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 33 "../src/Widgets/SecretItemRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WALLET_TYPE_SECRET_ITEM_ROW, WalletSecretItemRow);
#line 33 "../src/Widgets/SecretItemRow.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 33 "../src/Widgets/SecretItemRow.vala"
	_data2_->_ref_count_ = 1;
#line 33 "../src/Widgets/SecretItemRow.vala"
	_data2_->self = g_object_ref (self);
#line 34 "../src/Widgets/SecretItemRow.vala"
	_tmp0_ = (GtkImage*) gtk_image_new_from_icon_name ("window-close-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 34 "../src/Widgets/SecretItemRow.vala"
	g_object_ref_sink (_tmp0_);
#line 34 "../src/Widgets/SecretItemRow.vala"
	delete_image = _tmp0_;
#line 35 "../src/Widgets/SecretItemRow.vala"
	_tmp1_ = delete_image;
#line 35 "../src/Widgets/SecretItemRow.vala"
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) _tmp1_);
#line 35 "../src/Widgets/SecretItemRow.vala"
	_tmp3_ = wallet_secret_item_row_css_provider;
#line 35 "../src/Widgets/SecretItemRow.vala"
	gtk_style_context_add_provider (_tmp2_, (GtkStyleProvider*) _tmp3_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 37 "../src/Widgets/SecretItemRow.vala"
	_tmp4_ = (GtkButton*) gtk_button_new ();
#line 37 "../src/Widgets/SecretItemRow.vala"
	g_object_ref_sink (_tmp4_);
#line 37 "../src/Widgets/SecretItemRow.vala"
	delete_button = _tmp4_;
#line 38 "../src/Widgets/SecretItemRow.vala"
	_tmp5_ = delete_button;
#line 38 "../src/Widgets/SecretItemRow.vala"
	_tmp6_ = delete_image;
#line 38 "../src/Widgets/SecretItemRow.vala"
	gtk_button_set_image (_tmp5_, (GtkWidget*) _tmp6_);
#line 39 "../src/Widgets/SecretItemRow.vala"
	_tmp7_ = delete_button;
#line 39 "../src/Widgets/SecretItemRow.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp7_, 6);
#line 40 "../src/Widgets/SecretItemRow.vala"
	_tmp8_ = delete_button;
#line 40 "../src/Widgets/SecretItemRow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp8_, _ ("Delete"));
#line 41 "../src/Widgets/SecretItemRow.vala"
	_tmp9_ = delete_button;
#line 41 "../src/Widgets/SecretItemRow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp9_, GTK_ALIGN_CENTER);
#line 43 "../src/Widgets/SecretItemRow.vala"
	_tmp10_ = delete_button;
#line 43 "../src/Widgets/SecretItemRow.vala"
	_tmp11_ = gtk_widget_get_style_context ((GtkWidget*) _tmp10_);
#line 43 "../src/Widgets/SecretItemRow.vala"
	delete_button_context = _tmp11_;
#line 44 "../src/Widgets/SecretItemRow.vala"
	_tmp12_ = delete_button_context;
#line 44 "../src/Widgets/SecretItemRow.vala"
	gtk_style_context_add_class (_tmp12_, "delete");
#line 45 "../src/Widgets/SecretItemRow.vala"
	_tmp13_ = delete_button_context;
#line 45 "../src/Widgets/SecretItemRow.vala"
	_tmp14_ = wallet_secret_item_row_css_provider;
#line 45 "../src/Widgets/SecretItemRow.vala"
	gtk_style_context_add_provider (_tmp13_, (GtkStyleProvider*) _tmp14_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 47 "../src/Widgets/SecretItemRow.vala"
	_tmp15_ = (GtkRevealer*) gtk_revealer_new ();
#line 47 "../src/Widgets/SecretItemRow.vala"
	g_object_ref_sink (_tmp15_);
#line 47 "../src/Widgets/SecretItemRow.vala"
	_tmp16_ = _tmp15_;
#line 47 "../src/Widgets/SecretItemRow.vala"
	wallet_secret_item_row_set_close_revealer (self, _tmp16_);
#line 47 "../src/Widgets/SecretItemRow.vala"
	_g_object_unref0 (_tmp16_);
#line 48 "../src/Widgets/SecretItemRow.vala"
	_tmp17_ = self->priv->_close_revealer;
#line 48 "../src/Widgets/SecretItemRow.vala"
	gtk_revealer_set_transition_type (_tmp17_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_RIGHT);
#line 49 "../src/Widgets/SecretItemRow.vala"
	_tmp18_ = self->priv->_close_revealer;
#line 49 "../src/Widgets/SecretItemRow.vala"
	_tmp19_ = delete_button;
#line 49 "../src/Widgets/SecretItemRow.vala"
	gtk_container_add ((GtkContainer*) _tmp18_, (GtkWidget*) _tmp19_);
#line 51 "../src/Widgets/SecretItemRow.vala"
	_tmp20_ = (GtkImage*) gtk_image_new_from_icon_name ("payment-card", (GtkIconSize) GTK_ICON_SIZE_DND);
#line 51 "../src/Widgets/SecretItemRow.vala"
	g_object_ref_sink (_tmp20_);
#line 51 "../src/Widgets/SecretItemRow.vala"
	image = _tmp20_;
#line 52 "../src/Widgets/SecretItemRow.vala"
	_tmp21_ = image;
#line 52 "../src/Widgets/SecretItemRow.vala"
	g_object_set (_tmp21_, "use-fallback", TRUE, NULL);
#line 54 "../src/Widgets/SecretItemRow.vala"
	_tmp22_ = self->priv->_secret_item;
#line 54 "../src/Widgets/SecretItemRow.vala"
	_tmp23_ = secret_item_get_label (_tmp22_);
#line 54 "../src/Widgets/SecretItemRow.vala"
	_tmp24_ = _tmp23_;
#line 54 "../src/Widgets/SecretItemRow.vala"
	_tmp25_ = (GtkLabel*) gtk_label_new (_tmp24_);
#line 54 "../src/Widgets/SecretItemRow.vala"
	g_object_ref_sink (_tmp25_);
#line 54 "../src/Widgets/SecretItemRow.vala"
	_tmp26_ = _tmp25_;
#line 54 "../src/Widgets/SecretItemRow.vala"
	_g_free0 (_tmp24_);
#line 54 "../src/Widgets/SecretItemRow.vala"
	title_label = _tmp26_;
#line 55 "../src/Widgets/SecretItemRow.vala"
	_tmp27_ = title_label;
#line 55 "../src/Widgets/SecretItemRow.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp27_, TRUE);
#line 56 "../src/Widgets/SecretItemRow.vala"
	_tmp28_ = title_label;
#line 56 "../src/Widgets/SecretItemRow.vala"
	gtk_label_set_xalign (_tmp28_, (gfloat) 0);
#line 58 "../src/Widgets/SecretItemRow.vala"
	_tmp29_ = (GtkLabel*) gtk_label_new (NULL);
#line 58 "../src/Widgets/SecretItemRow.vala"
	g_object_ref_sink (_tmp29_);
#line 58 "../src/Widgets/SecretItemRow.vala"
	description = _tmp29_;
#line 59 "../src/Widgets/SecretItemRow.vala"
	_tmp30_ = description;
#line 59 "../src/Widgets/SecretItemRow.vala"
	gtk_label_set_use_markup (_tmp30_, TRUE);
#line 60 "../src/Widgets/SecretItemRow.vala"
	_tmp31_ = description;
#line 60 "../src/Widgets/SecretItemRow.vala"
	gtk_label_set_xalign (_tmp31_, (gfloat) 0);
#line 62 "../src/Widgets/SecretItemRow.vala"
	_tmp32_ = (GtkGrid*) gtk_grid_new ();
#line 62 "../src/Widgets/SecretItemRow.vala"
	g_object_ref_sink (_tmp32_);
#line 62 "../src/Widgets/SecretItemRow.vala"
	grid = _tmp32_;
#line 63 "../src/Widgets/SecretItemRow.vala"
	_tmp33_ = grid;
#line 63 "../src/Widgets/SecretItemRow.vala"
	gtk_grid_set_column_spacing (_tmp33_, 6);
#line 64 "../src/Widgets/SecretItemRow.vala"
	_tmp34_ = grid;
#line 64 "../src/Widgets/SecretItemRow.vala"
	g_object_set ((GtkWidget*) _tmp34_, "margin", 6, NULL);
#line 65 "../src/Widgets/SecretItemRow.vala"
	_tmp35_ = grid;
#line 65 "../src/Widgets/SecretItemRow.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp35_, 0);
#line 66 "../src/Widgets/SecretItemRow.vala"
	_tmp36_ = grid;
#line 66 "../src/Widgets/SecretItemRow.vala"
	_tmp37_ = self->priv->_close_revealer;
#line 66 "../src/Widgets/SecretItemRow.vala"
	gtk_grid_attach (_tmp36_, (GtkWidget*) _tmp37_, 0, 0, 1, 2);
#line 67 "../src/Widgets/SecretItemRow.vala"
	_tmp38_ = grid;
#line 67 "../src/Widgets/SecretItemRow.vala"
	_tmp39_ = image;
#line 67 "../src/Widgets/SecretItemRow.vala"
	gtk_grid_attach (_tmp38_, (GtkWidget*) _tmp39_, 1, 0, 1, 2);
#line 68 "../src/Widgets/SecretItemRow.vala"
	_tmp40_ = grid;
#line 68 "../src/Widgets/SecretItemRow.vala"
	_tmp41_ = title_label;
#line 68 "../src/Widgets/SecretItemRow.vala"
	gtk_grid_attach (_tmp40_, (GtkWidget*) _tmp41_, 2, 0, 1, 1);
#line 69 "../src/Widgets/SecretItemRow.vala"
	_tmp42_ = grid;
#line 69 "../src/Widgets/SecretItemRow.vala"
	_tmp43_ = description;
#line 69 "../src/Widgets/SecretItemRow.vala"
	gtk_grid_attach (_tmp42_, (GtkWidget*) _tmp43_, 2, 1, 1, 1);
#line 71 "../src/Widgets/SecretItemRow.vala"
	_tmp44_ = (GtkRevealer*) gtk_revealer_new ();
#line 71 "../src/Widgets/SecretItemRow.vala"
	g_object_ref_sink (_tmp44_);
#line 71 "../src/Widgets/SecretItemRow.vala"
	_data2_->revealer = _tmp44_;
#line 72 "../src/Widgets/SecretItemRow.vala"
	_tmp45_ = _data2_->revealer;
#line 72 "../src/Widgets/SecretItemRow.vala"
	gtk_revealer_set_reveal_child (_tmp45_, TRUE);
#line 73 "../src/Widgets/SecretItemRow.vala"
	_tmp46_ = _data2_->revealer;
#line 73 "../src/Widgets/SecretItemRow.vala"
	gtk_revealer_set_transition_type (_tmp46_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_UP);
#line 74 "../src/Widgets/SecretItemRow.vala"
	_tmp47_ = _data2_->revealer;
#line 74 "../src/Widgets/SecretItemRow.vala"
	_tmp48_ = grid;
#line 74 "../src/Widgets/SecretItemRow.vala"
	gtk_container_add ((GtkContainer*) _tmp47_, (GtkWidget*) _tmp48_);
#line 76 "../src/Widgets/SecretItemRow.vala"
	_tmp49_ = _data2_->revealer;
#line 76 "../src/Widgets/SecretItemRow.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp49_);
#line 78 "../src/Widgets/SecretItemRow.vala"
	_tmp50_ = self->priv->_secret_item;
#line 78 "../src/Widgets/SecretItemRow.vala"
	_tmp51_ = secret_item_get_attributes (_tmp50_);
#line 78 "../src/Widgets/SecretItemRow.vala"
	attributes = _tmp51_;
#line 80 "../src/Widgets/SecretItemRow.vala"
	_tmp52_ = attributes;
#line 80 "../src/Widgets/SecretItemRow.vala"
	_tmp53_ = g_hash_table_lookup (_tmp52_, "exp");
#line 80 "../src/Widgets/SecretItemRow.vala"
	_tmp54_ = g_strdup ((const gchar*) _tmp53_);
#line 80 "../src/Widgets/SecretItemRow.vala"
	exp = _tmp54_;
#line 81 "../src/Widgets/SecretItemRow.vala"
	_tmp55_ = exp;
#line 81 "../src/Widgets/SecretItemRow.vala"
	if (_tmp55_ != NULL) {
#line 803 "SecretItemRow.c"
		GtkLabel* _tmp56_;
		const gchar* _tmp57_;
		gchar* _tmp58_;
		gchar* _tmp59_;
		gchar* _tmp60_;
		gchar* _tmp61_;
#line 82 "../src/Widgets/SecretItemRow.vala"
		_tmp56_ = description;
#line 82 "../src/Widgets/SecretItemRow.vala"
		_tmp57_ = exp;
#line 82 "../src/Widgets/SecretItemRow.vala"
		_tmp58_ = g_strdup_printf (_ ("Expires %s"), _tmp57_);
#line 82 "../src/Widgets/SecretItemRow.vala"
		_tmp59_ = _tmp58_;
#line 82 "../src/Widgets/SecretItemRow.vala"
		_tmp60_ = g_strdup_printf ("<small>%s</small>", _tmp59_);
#line 82 "../src/Widgets/SecretItemRow.vala"
		_tmp61_ = _tmp60_;
#line 82 "../src/Widgets/SecretItemRow.vala"
		gtk_label_set_label (_tmp56_, _tmp61_);
#line 82 "../src/Widgets/SecretItemRow.vala"
		_g_free0 (_tmp61_);
#line 82 "../src/Widgets/SecretItemRow.vala"
		_g_free0 (_tmp59_);
#line 828 "SecretItemRow.c"
	} else {
		GtkLabel* _tmp62_;
		SecretItem* _tmp63_;
		gchar* _tmp64_;
		gchar* _tmp65_;
		gchar* _tmp66_;
		gchar* _tmp67_;
#line 84 "../src/Widgets/SecretItemRow.vala"
		_tmp62_ = description;
#line 84 "../src/Widgets/SecretItemRow.vala"
		_tmp63_ = self->priv->_secret_item;
#line 84 "../src/Widgets/SecretItemRow.vala"
		_tmp64_ = secret_item_get_schema_name (_tmp63_);
#line 84 "../src/Widgets/SecretItemRow.vala"
		_tmp65_ = _tmp64_;
#line 84 "../src/Widgets/SecretItemRow.vala"
		_tmp66_ = g_strdup_printf ("<small>%s</small>", _tmp65_);
#line 84 "../src/Widgets/SecretItemRow.vala"
		_tmp67_ = _tmp66_;
#line 84 "../src/Widgets/SecretItemRow.vala"
		gtk_label_set_label (_tmp62_, _tmp67_);
#line 84 "../src/Widgets/SecretItemRow.vala"
		_g_free0 (_tmp67_);
#line 84 "../src/Widgets/SecretItemRow.vala"
		_g_free0 (_tmp65_);
#line 854 "SecretItemRow.c"
	}
#line 87 "../src/Widgets/SecretItemRow.vala"
	_tmp68_ = attributes;
#line 87 "../src/Widgets/SecretItemRow.vala"
	_tmp69_ = g_hash_table_lookup (_tmp68_, "brand");
#line 87 "../src/Widgets/SecretItemRow.vala"
	_tmp70_ = g_strdup ((const gchar*) _tmp69_);
#line 87 "../src/Widgets/SecretItemRow.vala"
	brand = _tmp70_;
#line 88 "../src/Widgets/SecretItemRow.vala"
	_tmp71_ = brand;
#line 88 "../src/Widgets/SecretItemRow.vala"
	if (_tmp71_ != NULL) {
#line 868 "SecretItemRow.c"
		GtkImage* _tmp72_;
		const gchar* _tmp73_;
		gchar* _tmp74_;
		gchar* _tmp75_;
		gchar* _tmp76_;
		gchar* _tmp77_;
#line 89 "../src/Widgets/SecretItemRow.vala"
		_tmp72_ = image;
#line 89 "../src/Widgets/SecretItemRow.vala"
		_tmp73_ = brand;
#line 89 "../src/Widgets/SecretItemRow.vala"
		_tmp74_ = g_utf8_strdown (_tmp73_, (gssize) -1);
#line 89 "../src/Widgets/SecretItemRow.vala"
		_tmp75_ = _tmp74_;
#line 89 "../src/Widgets/SecretItemRow.vala"
		_tmp76_ = g_strdup_printf ("payment-card-%s", _tmp75_);
#line 89 "../src/Widgets/SecretItemRow.vala"
		_tmp77_ = _tmp76_;
#line 89 "../src/Widgets/SecretItemRow.vala"
		g_object_set (_tmp72_, "icon-name", _tmp77_, NULL);
#line 89 "../src/Widgets/SecretItemRow.vala"
		_g_free0 (_tmp77_);
#line 89 "../src/Widgets/SecretItemRow.vala"
		_g_free0 (_tmp75_);
#line 893 "SecretItemRow.c"
	}
#line 92 "../src/Widgets/SecretItemRow.vala"
	_tmp78_ = delete_button;
#line 92 "../src/Widgets/SecretItemRow.vala"
	g_signal_connect_data ((GtkWidget*) _tmp78_, "button-release-event", (GCallback) __wallet_secret_item_row___lambda13__gtk_widget_button_release_event, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 102 "../src/Widgets/SecretItemRow.vala"
	g_signal_connect_object ((GtkWidget*) self, "focus-out-event", (GCallback) __wallet_secret_item_row___lambda15__gtk_widget_focus_out_event, self, 0);
#line 33 "../src/Widgets/SecretItemRow.vala"
	_g_free0 (brand);
#line 33 "../src/Widgets/SecretItemRow.vala"
	_g_free0 (exp);
#line 33 "../src/Widgets/SecretItemRow.vala"
	_g_hash_table_unref0 (attributes);
#line 33 "../src/Widgets/SecretItemRow.vala"
	_g_object_unref0 (grid);
#line 33 "../src/Widgets/SecretItemRow.vala"
	_g_object_unref0 (description);
#line 33 "../src/Widgets/SecretItemRow.vala"
	_g_object_unref0 (title_label);
#line 33 "../src/Widgets/SecretItemRow.vala"
	_g_object_unref0 (image);
#line 33 "../src/Widgets/SecretItemRow.vala"
	_g_object_unref0 (delete_button);
#line 33 "../src/Widgets/SecretItemRow.vala"
	_g_object_unref0 (delete_image);
#line 33 "../src/Widgets/SecretItemRow.vala"
	block2_data_unref (_data2_);
#line 33 "../src/Widgets/SecretItemRow.vala"
	_data2_ = NULL;
#line 33 "../src/Widgets/SecretItemRow.vala"
	return obj;
#line 925 "SecretItemRow.c"
}

static void
wallet_secret_item_row_class_init (WalletSecretItemRowClass * klass,
                                   gpointer klass_data)
{
	GtkCssProvider* _tmp0_;
	GtkCssProvider* _tmp1_;
#line 18 "../src/Widgets/SecretItemRow.vala"
	wallet_secret_item_row_parent_class = g_type_class_peek_parent (klass);
#line 18 "../src/Widgets/SecretItemRow.vala"
	g_type_class_adjust_private_offset (klass, &WalletSecretItemRow_private_offset);
#line 18 "../src/Widgets/SecretItemRow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_wallet_secret_item_row_get_property;
#line 18 "../src/Widgets/SecretItemRow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_wallet_secret_item_row_set_property;
#line 18 "../src/Widgets/SecretItemRow.vala"
	G_OBJECT_CLASS (klass)->constructor = wallet_secret_item_row_constructor;
#line 18 "../src/Widgets/SecretItemRow.vala"
	G_OBJECT_CLASS (klass)->finalize = wallet_secret_item_row_finalize;
#line 18 "../src/Widgets/SecretItemRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WALLET_SECRET_ITEM_ROW_CLOSE_REVEALER_PROPERTY, wallet_secret_item_row_properties[WALLET_SECRET_ITEM_ROW_CLOSE_REVEALER_PROPERTY] = g_param_spec_object ("close-revealer", "close-revealer", "close-revealer", gtk_revealer_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18 "../src/Widgets/SecretItemRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WALLET_SECRET_ITEM_ROW_SECRET_ITEM_PROPERTY, wallet_secret_item_row_properties[WALLET_SECRET_ITEM_ROW_SECRET_ITEM_PROPERTY] = g_param_spec_object ("secret-item", "secret-item", "secret-item", secret_item_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 29 "../src/Widgets/SecretItemRow.vala"
	_tmp0_ = gtk_css_provider_new ();
#line 29 "../src/Widgets/SecretItemRow.vala"
	_g_object_unref0 (wallet_secret_item_row_css_provider);
#line 29 "../src/Widgets/SecretItemRow.vala"
	wallet_secret_item_row_css_provider = _tmp0_;
#line 30 "../src/Widgets/SecretItemRow.vala"
	_tmp1_ = wallet_secret_item_row_css_provider;
#line 30 "../src/Widgets/SecretItemRow.vala"
	gtk_css_provider_load_from_resource (_tmp1_, "io/elementary/switchboard/wallet/SecretItemRow.css");
#line 960 "SecretItemRow.c"
}

static void
wallet_secret_item_row_instance_init (WalletSecretItemRow * self,
                                      gpointer klass)
{
#line 18 "../src/Widgets/SecretItemRow.vala"
	self->priv = wallet_secret_item_row_get_instance_private (self);
#line 969 "SecretItemRow.c"
}

static void
wallet_secret_item_row_finalize (GObject * obj)
{
	WalletSecretItemRow * self;
#line 18 "../src/Widgets/SecretItemRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WALLET_TYPE_SECRET_ITEM_ROW, WalletSecretItemRow);
#line 19 "../src/Widgets/SecretItemRow.vala"
	_g_object_unref0 (self->priv->_close_revealer);
#line 20 "../src/Widgets/SecretItemRow.vala"
	_g_object_unref0 (self->priv->_secret_item);
#line 18 "../src/Widgets/SecretItemRow.vala"
	G_OBJECT_CLASS (wallet_secret_item_row_parent_class)->finalize (obj);
#line 984 "SecretItemRow.c"
}

static GType
wallet_secret_item_row_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WalletSecretItemRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) wallet_secret_item_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WalletSecretItemRow), 0, (GInstanceInitFunc) wallet_secret_item_row_instance_init, NULL };
	GType wallet_secret_item_row_type_id;
	wallet_secret_item_row_type_id = g_type_register_static (gtk_list_box_row_get_type (), "WalletSecretItemRow", &g_define_type_info, 0);
	WalletSecretItemRow_private_offset = g_type_add_instance_private (wallet_secret_item_row_type_id, sizeof (WalletSecretItemRowPrivate));
	return wallet_secret_item_row_type_id;
}

GType
wallet_secret_item_row_get_type (void)
{
	static volatile gsize wallet_secret_item_row_type_id__once = 0;
	if (g_once_init_enter (&wallet_secret_item_row_type_id__once)) {
		GType wallet_secret_item_row_type_id;
		wallet_secret_item_row_type_id = wallet_secret_item_row_get_type_once ();
		g_once_init_leave (&wallet_secret_item_row_type_id__once, wallet_secret_item_row_type_id);
	}
	return wallet_secret_item_row_type_id__once;
}

static void
_vala_wallet_secret_item_row_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	WalletSecretItemRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WALLET_TYPE_SECRET_ITEM_ROW, WalletSecretItemRow);
#line 18 "../src/Widgets/SecretItemRow.vala"
	switch (property_id) {
#line 18 "../src/Widgets/SecretItemRow.vala"
		case WALLET_SECRET_ITEM_ROW_CLOSE_REVEALER_PROPERTY:
#line 18 "../src/Widgets/SecretItemRow.vala"
		g_value_set_object (value, wallet_secret_item_row_get_close_revealer (self));
#line 18 "../src/Widgets/SecretItemRow.vala"
		break;
#line 18 "../src/Widgets/SecretItemRow.vala"
		case WALLET_SECRET_ITEM_ROW_SECRET_ITEM_PROPERTY:
#line 18 "../src/Widgets/SecretItemRow.vala"
		g_value_set_object (value, wallet_secret_item_row_get_secret_item (self));
#line 18 "../src/Widgets/SecretItemRow.vala"
		break;
#line 1031 "SecretItemRow.c"
		default:
#line 18 "../src/Widgets/SecretItemRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/Widgets/SecretItemRow.vala"
		break;
#line 1037 "SecretItemRow.c"
	}
}

static void
_vala_wallet_secret_item_row_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	WalletSecretItemRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WALLET_TYPE_SECRET_ITEM_ROW, WalletSecretItemRow);
#line 18 "../src/Widgets/SecretItemRow.vala"
	switch (property_id) {
#line 18 "../src/Widgets/SecretItemRow.vala"
		case WALLET_SECRET_ITEM_ROW_CLOSE_REVEALER_PROPERTY:
#line 18 "../src/Widgets/SecretItemRow.vala"
		wallet_secret_item_row_set_close_revealer (self, g_value_get_object (value));
#line 18 "../src/Widgets/SecretItemRow.vala"
		break;
#line 18 "../src/Widgets/SecretItemRow.vala"
		case WALLET_SECRET_ITEM_ROW_SECRET_ITEM_PROPERTY:
#line 18 "../src/Widgets/SecretItemRow.vala"
		wallet_secret_item_row_set_secret_item (self, g_value_get_object (value));
#line 18 "../src/Widgets/SecretItemRow.vala"
		break;
#line 1063 "SecretItemRow.c"
		default:
#line 18 "../src/Widgets/SecretItemRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/Widgets/SecretItemRow.vala"
		break;
#line 1069 "SecretItemRow.c"
	}
}

